# Signstream3
Rutgers University, Boston University
Developer: Greg Dimitriadis (RU)
PI: Carol Neidle (BU)

Issues currently being tracked on Github project site:
https://github.com/DCS-LCSR/SignStream3

Code is hosted on Gitlab project site:
https://git.lcsr.rutgers.edu/signstream-bu/Signstream3

## Prerequisites
- Install the latest AdoptOpenJDK11 HotSpot build from [https://adoptopenjdk.net](https://adoptopenjdk.net).
- `export JAVA_HOME=/Library/Java/JavaVirtualMachines/adoptopenjdk-11.jdk/Contents/Home/`

For Gradle support in Eclipse, install the [Buildship plugin](https://projects.eclipse.org/projects/tools.buildship).
  
## Building and Running
The build process is managed by Gradle, which can be used with the bundled wrapper `gradlew`, or through IDE plugins. 

```
./gradlew build
./gradlew run
```

## Debugging
On any IDE with gradle integration, the `run` task can simply be debugged as normal.

On Eclipse, the gradle plugin doesn't support debugging directly, so we need a workaround.
Before debugging, configure an Eclipse "Remote Java Application" debug configuration with type "Socket Attach", address `localhost`, and port `8000`. To debug, first run the gradle `debug` task, which will launch the application in a suspended state, waiting for a remote debugger to attach. Then, launch the created eclipse debug configuration and the application will now start and be debuggable.

## Bundling
Before bundling, release properties such as the version can be changed in the `settings.gradle` file.

```
./gradlew bundle
```

This outputs a bundled zip release in the root of the repo.
