#!/bin/bash

if test $# -ne 3; then
  echo "Usage: convert-video.sh <source folder> <destination folder> <path-to-ffmpeg>"
  exit 1
fi

# Encoder quality - 1 is best, 31 is worst
quality=2

srcdir=$1
destdir=$2
FFMPEG=$3

# This works even if file names have spaces
IFS=$'\n'
files=($(ls -1 "$srcdir"/*.mp4))
unset IFS
numFiles=${#files[@]}

for ((i=0; i<${numFiles}; i++)); do
  file=${files[i]}
  echo "Processing $file ..."
  base=`basename "$file"`
  root=${base%.mp4}
  srcfile="$srcdir/$base"
  destfile="$destdir/$root-for-ss3.mp4"
  "$FFMPEG" -i "$srcfile" -an -vcodec mpeg4 -q:v "$quality" "$destfile"
done