package edu.bu.signstream.codingScheme.ui.importLegacyCodingScheme;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.border.TitledBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;

public class SortableEntitiesPanel extends JPanel {
   private JTable table;
   private Object[] columnNames;
   private Object[][] values;

   private SS3CodingScheme masterSchema = null;
   private LegacyCodingSchemaFormBean legacyFormBean = null;

   //private JFrame frame;
   
   private JDialog parentDialog;

   private SortableTableModel tableModel = null;

   public SortableEntitiesPanel(Object[] columnNames, Object[][] values) {
      this.columnNames = columnNames;
      this.values = values;
      initUI();
   }

   public void setMasterCodingSchema(SS3CodingScheme schema) {
      this.masterSchema = schema;
   }

   public void setLegacyCodingSchemaFormBean(LegacyCodingSchemaFormBean formBean) {
      this.legacyFormBean = formBean;
   }

   public void setDialog(JDialog parentDialog) {
      this.parentDialog = parentDialog;
   }

   private void initUI() {
      JScrollPane scrollPane = createValuesTable();

      table.getColumnModel().removeColumn(table.getColumnModel().getColumn(0));

      table.setAutoCreateColumnsFromModel(false);

      setLayout(new BorderLayout());
      add(scrollPane, BorderLayout.CENTER);

      table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

      table
         .getSelectionModel()
         .addListSelectionListener(new ListSelectionListener() {
         @Override
		public void valueChanged(ListSelectionEvent e) {}
      });

      table.addMouseListener(new MouseAdapter() {
         @Override
		public void mouseClicked(MouseEvent e) {
            if (e.getClickCount() == 2) {
               Point p = e.getPoint();
               int row = table.rowAtPoint(p);

               CSFieldTableSorter sorter =
                  (CSFieldTableSorter) table.getModel();

               String value = (String) sorter.getValueAt(row, 0);
               String fieldName = (String) sorter.getValueAt(row, 1);
               
               int x = 400; 
               int y = 200; 
               int width = 800;
               
//               if(frame != null) {
//                  x = frame.getLocationOnScreen().x;
//                  y = frame.getLocationOnScreen().y+150;
//                  width = frame.getWidth();
//               }

               if (masterSchema != null) {

                  Collection values =
                     masterSchema.getField(value).getValues().values();
                  if (!values.isEmpty()) {
                     Object[] mColumnNames =
                        { "", "Value Name", "Value Label" };

                     Object[][] mData = new Object[values.size()][];

                     int i = 0;
                     Iterator iterator = values.iterator();
                     while (iterator.hasNext()) {
                        SS3FieldValue vValue = (SS3FieldValue) iterator.next();
                        Object[] vValues =
                           {
                              vValue.getId(),
                              vValue.getName(),
                              vValue.getLabel()};
                        mData[i] = vValues;
                        i++;
                     }

                     JPanel mPanel =
                        new SortableEntitiesPanel(mColumnNames, mData);
                     mPanel.setBorder(
                        new TitledBorder(
                           "Master Coding Schema: values for field <"
                              + fieldName
                              + ">"));

                     JDialog dialog = new JDialog(parentDialog);

                     dialog.setSize(new Dimension(500, 400));
                     
                     dialog.setLocation(x+(width/2)+100, y);
                     
                     Container contentPane = dialog.getContentPane();

                     contentPane.setLayout(new BorderLayout(50, 50));
                     contentPane.add(mPanel, BorderLayout.CENTER);

                     dialog.show();

                  } else {
                     String message =
                        "Field <" + fieldName + "> has no values.";
                     JOptionPane op =
                        new JOptionPane(
                           message,
                           JOptionPane.INFORMATION_MESSAGE);
                     JDialog dialog =
                        op.createDialog(parentDialog, "Information message");
                     dialog.setLocation(x+(width/2)+100, y);
                     dialog.show();
                  }

               } else if (legacyFormBean != null) {                  
                  
                  LegacyCodingSchemaEntity entity =
                     legacyFormBean.getLegacyCodingSchemaEntityWithID(value);
                  ArrayList children = entity.getChildren();
                  if (!children.isEmpty()) {

                     Object[] lColumnNames =
                        {
                           "",
                           "Value Name",
                           "Value Label",
                           "Difference found",
                           "Field not found in Master Schema" };

                     Object[][] lData = new Object[children.size()][];

                     for (int i = 0; i < children.size(); i++) {

                        LegacyCodingSchemaEntity lValue =
                           (LegacyCodingSchemaEntity) children.get(i);
                        Object[] lValues =
                           {
                              "0",
                              lValue.getName(),
                              lValue.getLabel(),
                              lValue.getDiffEntityMarker(),
                              lValue.getNotFoundInMasterSchemaMarker()};
                        lData[i] = lValues;
                     }

                     JPanel mPanel =
                        new SortableEntitiesPanel(lColumnNames, lData);
                     mPanel.setBorder(
                        new TitledBorder(
                           "Legacy Coding Schema: values for field <"
                              + fieldName
                              + ">"));

                     JDialog dialog = new JDialog(parentDialog);

                     dialog.setSize(new Dimension(500, 400));
                     dialog.setLocation(x+(width/2)-600, y);
                     
                     Container contentPane = dialog.getContentPane();

                     contentPane.setLayout(new BorderLayout(50, 50));
                     contentPane.add(mPanel, BorderLayout.CENTER);

                     dialog.show();

                  } else {
                     String message =
                        "Field <" + fieldName + "> has no values.";
                     JOptionPane op =
                        new JOptionPane(
                           message,
                           JOptionPane.INFORMATION_MESSAGE);
                     JDialog dialog =
                        op.createDialog(parentDialog, "Information message");
                     dialog.setLocation(x+(width/2)-600, y);
                     dialog.show();
                  }
               }

            }
         }
      });

   }

   private JScrollPane createValuesTable() {
      tableModel = new SortableTableModel(columnNames, values);

      CSFieldTableSorter sorter = new CSFieldTableSorter(tableModel);

      table = new JTable(sorter);
      sorter.setTableHeader(table.getTableHeader());

      table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

      setPreferredSize();
      JScrollPane scrollPane = new JScrollPane(table);
      scrollPane.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);

      int h =
         scrollPane.getPreferredSize().height < 150
            ? scrollPane.getPreferredSize().height
            : 150;

      Dimension d = new Dimension(scrollPane.getPreferredSize().width, h);
      scrollPane.setMaximumSize(d);
      scrollPane.setPreferredSize(d);

      return scrollPane;
   }

   private void setPreferredSize() {

      for (int i = 1; i < columnNames.length; i++) {
         TableColumn tableColumn = table.getColumn(columnNames[i]);
         int prefSize = getPreferredWidthForColumn(tableColumn);
         tableColumn.setMinWidth(prefSize);
      }

   }

   public SortableTableModel getSortableTableModel() {
      return tableModel;
   }

   public void reloadData() {
      table.repaint();

   }

   public int getPreferredWidthForColumn(TableColumn col) {
         int hw = columnHeaderWidth(col), // hw = header width
   cw = widestCellInColumn(col); // cw = column width

      return hw > cw ? hw : cw;
   }

   private int columnHeaderWidth(TableColumn col) {
      TableCellRenderer renderer = col.getHeaderRenderer();
      return 75;
   }

   private int widestCellInColumn(TableColumn col) {
      int c = col.getModelIndex(), width = 0, maxw = 0;

      for (int r = 1; r < table.getRowCount(); ++r) {
         TableCellRenderer renderer = table.getCellRenderer(r, c);

         Component comp =
            renderer.getTableCellRendererComponent(
               table,
               table.getValueAt(r, c),
               false,
               false,
               r,
               c);

         width = comp.getPreferredSize().width;
         maxw = width > maxw ? width : maxw;
      }
      return maxw + 10;
   }
}
