package edu.bu.signstream.codingScheme.ui.importLegacyCodingScheme;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;

import javax.swing.tree.TreePath;
import javax.swing.tree.DefaultMutableTreeNode;

public class TransferableTreeNode implements Transferable {

   public static DataFlavor TREE_PATH_FLAVOR =
      new DataFlavor(TreePath.class, "Tree Path");

   DataFlavor flavors[] = { TREE_PATH_FLAVOR };

   private DefaultMutableTreeNode treeNode;

   public TransferableTreeNode(DefaultMutableTreeNode treeNode) {
      this.treeNode = treeNode;
   }

   @Override
public synchronized DataFlavor[] getTransferDataFlavors() {
      return flavors;
   }

   @Override
public boolean isDataFlavorSupported(DataFlavor flavor) {
      return (flavor.getRepresentationClass() == TreePath.class);
   }

   @Override
public synchronized Object getTransferData(DataFlavor flavor)
      throws UnsupportedFlavorException, IOException {

      if (isDataFlavorSupported(flavor)) {
         Object userObject = treeNode.getUserObject();
         return userObject;
      } else {
         throw new UnsupportedFlavorException(flavor);
      }
   }

   @Override
public String toString() {
      return "Transferable: " + treeNode;
   }
}
