package edu.bu.signstream.common.files;

import javax.swing.*;
import java.io.File;
import java.nio.file.Paths;

public class SS3Resources {
    public static final String libPath;
    public static final String resourcesPath;
    public static final String rootPath;
    public static final String xmlPath;
    public static final String signbankPath;
    public static final String collectionPath;

    private static String normalize(String path) {
        return Paths.get(path).normalize().toAbsolutePath().toString();
    }

    static {
        var cwd = normalize(System.getProperty("user.dir"));
        var bundled = System.getProperty("bundle") != null;

        if (bundled) {
            libPath = normalize(cwd + "/../lib");
            resourcesPath = normalize(cwd + "/../Resources");
            rootPath = normalize(cwd + "/../../..");
        } else {
            libPath = cwd + "/lib";
            resourcesPath = cwd + "/resources";
            rootPath = cwd;
        }

        xmlPath = rootPath + "/newXMLfiles";
        signbankPath = rootPath + "/signbank";
        collectionPath = rootPath + "/SignStreamDatabases";

        System.out.println("libPath = " + libPath);
        System.out.println("resourcesPath = " + resourcesPath);
        System.out.println("xmlPath = " + xmlPath);
        System.out.println("signbankPath = " + signbankPath);
        System.out.println("collectionPath = " + collectionPath);
    }

    public static ImageIcon icon(String name) {
        try {
            return new ImageIcon(resourcesPath + "/icons/" + name);
        } catch (Exception e) {
            return null;
        }
    }
}
