package edu.bu.signstream.common.util.vo;

import java.awt.Color;
import edu.bu.signstream.common.util.Util;

public class CodingSchemaValue {
	private int valueId = -1;
	private String name = "", label = "";
	private Color color = Color.GRAY;
	private boolean updateable = false;
	private String imageID = "";

	public void setUpdateable(boolean updateable) {
		this.updateable = updateable;
	}
	
	public void setImageID(String imageID) {
		//
		//System.out.println("CodingSchemaValue: setImageID = " + imageID);
		//
		this.imageID = imageID;
	}
	
	public String getImageID() {
		return imageID;
	}

	public boolean isUpdateable() {
		return updateable;
	}

	/*implement!!!
	 * */
	public CodingSchemaValue(
		String id,
		String name,
		String label,
		Color color) {
		valueId = Integer.parseInt(id);
		this.name = name;
		this.label = label;
		this.color = color;
	}

	public CodingSchemaValue(
		String id,
		String name,
		String label,
		String color) {
		valueId = Integer.parseInt(id);
		this.name = name;
		this.label = label;
		this.color = Util.hexString2Color(color);
	}

	public CodingSchemaValue() {
	}

	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("CodingSchemeValue:");
		sb.append("\n valueId = ");
		sb.append(valueId);
		sb.append("\n name = ");
		sb.append(name);
		sb.append("\n label = ");
		sb.append(label);
		sb.append("\n color = ");
		sb.append(color);
		return sb.toString();
	}

	public String getLabelOrName() {
		if (label != null && label.length() > 0)
			return label;
		return name;
	}

	public boolean isONSET() {
		String text = getLabelOrName();

		if (text.equalsIgnoreCase("ONSET"))
			return true;
		return false;
	}

	public Color getColor() {
		return color;
	}

	public String getLabel() {
		return label;
	}

	public String getName() {
		return name;
	}

	public int getValueId() {
		return valueId;
	}

	public String getValueIDAsString() {
		if (valueId == -1)
			return "";
		return "" + valueId;
	}

	public void setColor(Color color) {
		this.color = color;
	}

	public void setLabel(String string) {
		label = string;
	}

	public void setName(String string) {
		name = string;
	}

	public void setValueId(int i) {
		valueId = i;
	}

}
