package edu.bu.signstream.common.util.vo.ss3;

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Set;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

import edu.bu.signstream.common.util.vo.Excerpt;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class UIOrchestrator implements ActionListener {

   private HashMap<Excerpt, SignStreamSegmentPanel> loadedExcerptPanels = new HashMap<Excerpt, SignStreamSegmentPanel>();

   private JMenu windowMenu = new JMenu("Window");

    public void reloadWindowMenu() {
      windowMenu.removeAll();

      Set<Excerpt> set = loadedExcerptPanels.keySet();
       for (Excerpt excerpt : set) {
           String lbl = excerpt.getExcerpt();
           JMenuItem item = new JMenuItem(lbl);
           if (excerpt.isSelected()) {
               Font font = item.getFont();
               Font newFont =
                       new Font(font.getFontName(), Font.BOLD, font.getSize());
               item.setFont(newFont);
           }

           item.addActionListener(this);

           windowMenu.add(item);

       }
   }

   @Override
    public void actionPerformed(ActionEvent ae) {
      String excerpt = ae.getActionCommand();

      SignStreamSegmentPanel selectedPanel =
         getSelectedSignStreamSegmentPanel(excerpt);

      if (selectedPanel != null) {
         moveToFrontSignStreamSegmentPanel(selectedPanel);
         unselectExcerpt();
         selectedPanel.getExcerpt().setSelected(true);
      }

      reloadWindowMenu();
   }

   private void unselectExcerpt() {
      Set<Excerpt> set = loadedExcerptPanels.keySet();
       for (Excerpt excerpt : set) {
           excerpt.setSelected(false);
       }
   }

   public void moveToFrontSignStreamSegmentPanel(SignStreamSegmentPanel selectedPanel) {
      JFrame parentFrame = selectedPanel.getParentFrame();
      if (parentFrame != null) {
         parentFrame.toFront();
      }
   }

   private SignStreamSegmentPanel getSelectedSignStreamSegmentPanel(String excerpt) {
      Set<Excerpt> set = loadedExcerptPanels.keySet();
       for (Excerpt exc : set) {
           String lbl = exc.getExcerpt();

           if (lbl.equalsIgnoreCase(excerpt))
               return loadedExcerptPanels.get(exc);
       }
      return null;
   }
}
