package edu.bu.signstream.common.util.vo.ss3.codingScheme;

import java.io.Serializable;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.handShapes.CSHandShapeItem;

public class SS3FieldValue implements Serializable, Comparable {
   private String id;
   private String name;
   //for handshapes - label --> image description from the coding schema
   private String label;
   private String iid;
   private String type;
   private CSHandShapeItem item = null; 
   
   private String letter = "";
   
   private String parentFieldID;
   private String legacyID;

   public SS3FieldValue cloneFieldValue() {
	   SS3FieldValue value = new SS3FieldValue();
	   value.setId(getId());
	   value.setName(getName());
	   value.setLabel(getLabel());
	   value.setIid(getIid());
	   value.setType(getType());
	   value.setLegacyID(getLegacyID());
	   value.setCSHandShapeItem(item);
	   return value;
   } 

   public CSHandShapeItem getCSHandShapeItem() {
	   return item;
   }
   
   public void setCSHandShapeItem(CSHandShapeItem item) {
	   this.item = item;
   }
   
   @Override
public int compareTo(Object obj) {
      SS3FieldValue tmp = (SS3FieldValue)obj;
      return toString().compareToIgnoreCase(tmp.toString());
   }
   
   public String getLetter() {
	return letter;
}

 public void setLetter(String letter) {
	this.letter = letter;
}



public void setLegacyID(String legacyID) {
      this.legacyID = legacyID;
   }

   public String getLegacyID() {
      return legacyID;
   }

   public String getId() {
      return id;
   }

   public String getIid() {
      return iid;
   }

   public String getLabel() {
      return label;
   }

   public String getName() {
      return name;
   }

   public void setId(String string) {
      id = string;
   }

   public void setIid(String string) {
      iid = string;
   }

   public void setLabel(String string) {
      label = string;
   }

   public void setName(String string) {
      name = string;
   }

   public String getType() {
      return type;
   }

   public void setType(String string) {
      type = string;
   }

   public String getLabelOrName() {
      if (label != null && label.length() > 0)
         return label;
      return name;
   }


   public String getParentFieldID() {
	   return parentFieldID;
   }

   public void setParentFieldID(String parentFieldID) {
	   this.parentFieldID = parentFieldID;
   }

	@Override
	public String toString() {
		return name; 
	}
}
