package edu.bu.signstream.common.util.vo.ss3.db;

import java.awt.Color;
import java.util.ArrayList;

import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.grepresentation.fields.nonManualField.GlossEntityProperties;

public class SS3Entity {

	private String participantID = "";
	private String coderID = "";
	private String id = "";
	private String refEntityId = "";
	private String timeCreated = "";
	private String timeUpdated = "";
	private String ref = "";
	private String startCompaundEntityID = "";
	private String endCompaundEntityID = "";
	private String parentEntityID = "";

	private boolean lockedGlossPhoneAlignments = false;
	private boolean isLockedLeftRightAlignments = false;
	
	private String dependentHandEntityID;
	private String dependentHandShapeEntityID;
	private String dependentGlossEntityID;

	private String dependentLocationEntityID;
	private String dependentSignTypeEntityID;
	
	private boolean validTime = false;	// for now, only applies to free text field (id 30000)
	
	public boolean isLockedGlossPhoneAlignments() {
		return lockedGlossPhoneAlignments;
	}

	public void setLockedGlossPhoneAlignments(boolean lockedGlossPhoneAlignments) {
		this.lockedGlossPhoneAlignments = lockedGlossPhoneAlignments;
	}

	public boolean isLockedLeftRightAlignments() {
		return isLockedLeftRightAlignments;
	}

	public void setLockedLeftRightAlignments(boolean isLockedLeftRightAlignments) {
		this.isLockedLeftRightAlignments = isLockedLeftRightAlignments;
	}

	public String getDependentHandEntityID() {
		return dependentHandEntityID;
	}

	public void setDependentHandEntityID(String dependentHandEntityID) {
		this.dependentHandEntityID = dependentHandEntityID;
	}

	public String getDependentHandShapeEntityID() {
		return dependentHandShapeEntityID;
	}

	public void setDependentHandShapeEntityID(String dependentHandShapeEntityID) {
		this.dependentHandShapeEntityID = dependentHandShapeEntityID;
	}

	public String getDependentGlossEntityID() {
		return dependentGlossEntityID;
	}

	public void setDependentGlossEntityID(String dependentGlossEntityID) {
		this.dependentGlossEntityID = dependentGlossEntityID;
	}

	public String getDependentLocationEntityID() {
		return dependentLocationEntityID;
	}

	public void setDependentLocationEntityID(String dependentLocationEntityID) {
		this.dependentLocationEntityID = dependentLocationEntityID;
	}
	
	public String getDependentSignTypeEntityID() {
		return dependentSignTypeEntityID;
	}

	public void setDependentSignTypeEntityID(String dependentSignTypeEntityID) {
		this.dependentSignTypeEntityID = dependentSignTypeEntityID;
	}

	@Override
	public String toString() {
		return "Entity ID = " + id + ", startTime = " + getStartTime() + ", endTime = " + getEndTime();
	}

	private Color color = null;

	ArrayList<SS3Item> items = new ArrayList<SS3Item>();

	private GlossEntityProperties properties = null;

	public GlossEntityProperties getGlossEntityProperties() {
		return properties;
	}

	public void setGlossEntityProperties(GlossEntityProperties properties) {
		this.properties = properties;
	}

	public void setID(String id) {
		this.id = id;
	}

	public String getID() {
		if (id == null || id.length() == 0)
			id = "" + Util.getUniqueNumber();
		return id;
	}

	public void setRefEntityId(String refEntityId) {
		this.refEntityId = refEntityId;
	}

	public String getRefEntityId() {
		return refEntityId;
	}

	public void setReference(String ref) {
		this.ref = ref;
	}

	public String getReference() {
		return ref;
	}
	
	public void setParentEntityID(String parentEntityID) {
		this.parentEntityID = parentEntityID;
	}
	
	public String getParentEntityID() {
		return parentEntityID;
	}

	public ArrayList<SS3Item> getItemsAsList() {
		return items;
	}

	public String getCoderID() {
		return coderID;
	}

	public ArrayList<SS3Item> getItems() {
		return items;
	}

	public String getParticipantID() {
		return participantID;
	}

	public String getTimeCreated() {
		return timeCreated;
	}

	public String getTimeUpdated() {
		return timeUpdated;
	}

	public void setCoderID(String string) {
		coderID = string;
	}

	public void setItems(ArrayList<SS3Item> items) {
		this.items = items;
	}

	public void setParticipantID(String string) {
		participantID = string;
	}

	public void setTimeCreated(String string) {
		timeCreated = string;
	}

	public void setTimeUpdated(String string) {
		timeUpdated = string;
	}

	public void addItem(SS3Item item) {
		items.add(item);
	}

	public int getStartTime() {
		int startTime = -1;
		ArrayList<SS3Item> itms = getItemsAsList();

		if (itms.size() > 0) {
			SS3Item item = itms.get(0);
			startTime = item.getStartTimeInfo().getMovieTime();
			for (SS3Item itm : itms) {
				int time = itm.getStartTimeInfo().getMovieTime();
				startTime = startTime < time ? startTime : time;
			}
		}
		return startTime;
	}

	public int getEndTime() {
		int endTime = -1;
		ArrayList<SS3Item> itms = getItemsAsList();

		if (itms.size() > 0) {
			SS3Item item = itms.get(0);
			endTime = item.getEndTimeInfo().getMovieTime();
			for (SS3Item itm : itms) {
				int time = itm.getEndTimeInfo().getMovieTime();
				endTime = endTime > time ? endTime : time;
			}
		}
		return endTime;
	}

	public Color getColor() {
		return color;
	}

	public void setColor(Color color) {
		this.color = color;
	}

	public String getEndCompaundEntityID() {
		return endCompaundEntityID;
	}

	public void setEndCompaundEntityID(String string) {
		endCompaundEntityID = string;
	}

	public String getStartCompaundEntityID() {
		return startCompaundEntityID;
	}

	public void setStartCompaundEntityID(String string) {
		startCompaundEntityID = string;
	}
	
	public boolean isValidTime() {
		return validTime;
	}
	
	public void setValidTime(boolean validTime) {
		this.validTime = validTime;
	}
}
