package edu.bu.signstream.common.util.vo.ss3.db;

import java.util.ArrayList;
import java.util.Hashtable;

import edu.bu.signstream.grepresentation.fields.Segment;

public class SS3GlossWindow {
	
	private String id = "";
	
	private SS3GlossWindowSegment displayTimePeriod = new SS3GlossWindowSegment();
	//private Hashtable<String, SS3TemporalPartition> temporalPartitions = new Hashtable<String, SS3TemporalPartition>();
	private ArrayList<SS3TemporalPartition> temporalPartitions = new ArrayList<SS3TemporalPartition>();
	
	private Segment segment = null;
	
	public void setSegment(Segment segment) {
		this.segment = segment;
	}
	
	public Segment getSegment() {
		return segment;
	}
	
	public SS3GlossWindowSegment getDisplayTimePeriod() {
		return displayTimePeriod;
	}	
	
	public void setDisplayTimePeriod(SS3GlossWindowSegment displayTimePeriod) {
		this.displayTimePeriod = displayTimePeriod;
	}
			
	public ArrayList<SS3TemporalPartition> getTemporalPartitions() {
		return temporalPartitions;
	}
	
	public SS3TemporalPartition getTemporalPartitionByLabel( String label) {
		for (SS3TemporalPartition tempPartition : temporalPartitions) {
			if(tempPartition.getLabel().equals(label))
				return tempPartition;
		}
		
		return null;
	}
	
	public void setTemporalPartitions(ArrayList temporalPartitions) {
		this.temporalPartitions = temporalPartitions;
	}
	
	public void addTemporalPartition(SS3TemporalPartition partition) {
		temporalPartitions.add( partition);
	}
	
	public void removeTemporalPartition(SS3TemporalPartition partitionToRemove) {
		if (partitionToRemove != null) {
			temporalPartitions.remove(partitionToRemove);
		} else {
			System.out.println("There is no such temporal partition in this gloss window");
		}		
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}
}
