package edu.bu.signstream.common.util.vo.ss3.db;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class SS3StatementField extends SS3Element {
   
   private ArrayList<SS3Entity> ss3Entities = new ArrayList<SS3Entity>();
   
   private Color color = null;
   
   public ArrayList<SS3Entity> getSS3Entities() {	   
	   return ss3Entities;
   }
   
   public void setSS3Entities(ArrayList<SS3Entity> list) {
	   ss3Entities = list;
	   Collections.sort(ss3Entities, new Comparator<SS3Entity>() {
			@Override
			public int compare(SS3Entity o1, SS3Entity o2) {
				int startTime1 = o1.getStartTime();
				int startTime2 = o2.getStartTime();
				
				return startTime1 - startTime2;
			}
			
		});
   }

   public Color getColor() {
	return color;
}

public void setColor(Color color) {
	this.color = color;
}

	public void addSS3Entity(SS3Entity ss3Entity) {
		ss3Entities.add(ss3Entity);
		   Collections.sort(ss3Entities, new Comparator<SS3Entity>() {
				@Override
				public int compare(SS3Entity o1, SS3Entity o2) {
					int startTime1 = o1.getStartTime();
					int startTime2 = o2.getStartTime();
					
					return startTime1 - startTime2;
				}
				
			});
	}
   
   public void removeSS3Entity(SS3Entity ss3Entity) {
	   ss3Entities.remove(ss3Entity);
   }

   @Override
public String toString() {
      StringBuffer bf = new StringBuffer();
      bf.append("SS3StatementField: ");
      bf.append("id (field ID) = ");
      bf.append(getId());
      bf.append(", entityIDs = ");
      
      for (int i = 0; i < ss3Entities.size(); i++) {
    	  	SS3Entity ss3Entity = ss3Entities.get(i);
          String id = ss3Entity.getID();
          bf.append(id);
          bf.append("  ");
       }

      return bf.toString();
   }
}
