package edu.bu.signstream.common.util.vo.ss3.participants;

import java.util.*;

public class Participant {
	private char gender = 'M';
	private String id;
	private String firstName;
	private String lastName;
	private String label;
	private String age;
	// dom hand can be "RIGHT" or "LEFT"
	private String domHand;
	
	private ArrayList languages = new ArrayList();
	private Background background;
	
	public void setDominantHand(String domHand) {
		this.domHand = domHand;
	}
	
	public String getDominantHand() {
		return domHand;
	}
	
	public boolean isDominantHandRight() {
		return domHand.equalsIgnoreCase("R");
	}
	
	public void setGender(String str) {
		str.trim();
		this.gender = str.charAt(0); 
	}
	
	public void setGenderMale() {
		gender = 'M';
	}
	
	public void setGenderFemale() {
		gender = 'F';
	}
	
	public boolean isGenderMale() {
		return gender == 'M';
	}
	
	public boolean isGenderFemale() {
		return gender == 'F';
	}
	
	public char getGender() {
		return gender;
	}

	public String getAge() {
		return age;
	}

	public Background getBackground() {
		return background;
	}

	public String getFirstName() {
		return firstName;
	}
   
   public String getFirstAndLastName() {
      return firstName + " " + lastName;
   }

	public String getId() {
		return id;
	}

	public String getLabel() {
		return label;
	}
	
	public void addLanguage(Language language) {
		languages.add(language);
	}

	public ArrayList getLanguages() {
		return languages;
	}

	public String getLastName() {
		return lastName;
	}

	public void setAge(String string) {
		age = string;
	}

	public void setBackground(Background background) {
		this.background = background;
	}

	public void setFirstName(String string) {
		firstName = string;
	}

	public void setGender(char c) {
		gender = c;
	}

	public void setId(String string) {
		id = string;
	}

	public void setLabel(String string) {
		label = string;
	}

	public void setLanguages(ArrayList list) {
		languages = list;
	}

	public void setLastName(String string) {
		lastName = string;
	}
	
	@Override
	public String toString() {
		StringBuffer bfr = new StringBuffer();
		bfr.append("gender = ");
		bfr.append(gender);
		bfr.append(", id = ");
		bfr.append(id);
		bfr.append(", firstName = ");
		bfr.append(firstName);
		bfr.append(", lastName = ");
		bfr.append(lastName);
		bfr.append(", label = ");
		bfr.append(label); 
		bfr.append(", age = ");
		bfr.append(age); 
		bfr.append(", domHand = ");
		bfr.append(domHand);
		bfr.append(", languages.size = ");
		bfr.append(languages.size());
		return bfr.toString();
	}
}
