package edu.bu.signstream.grepresentation.fields.freeTextField;

import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics2D;

import edu.bu.signstream.grepresentation.fields.Field;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEvent;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsCollection;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class FreeTextEntity extends ChainedEventsEntity {
   private boolean showTxtField = false;
   
   private boolean validTime = false;
   
	// collection contains only one event - GlossChainedEvent
	public FreeTextEntity(ChainedEventsCollection collection, String fieldID, SignStreamSegmentPanel segmentPanel, Field field) {
		super(collection, segmentPanel, field);
	}

	@Override
	public void paint(Graphics2D g2d, double Y, Font font) {
		g2d.setFont(font);
		FontMetrics fontMetrics = getFontMetrics(font);
		GlossChainedEvent event = getGlossChainedEvent();
		if (!event.isUpdatable())
			segmentPanel.getPainter().drawFreeTextLabel(event, g2d, Y, fontMetrics, getField().getFieldID());
	}

   public boolean isShowTxtField() {
      return showTxtField;
   }

   public void setShowTxtField(boolean b) {
      showTxtField = b;
   }
   
   public boolean isValidTime() {
	   return validTime;
   }
   
   public void setValidTime(boolean validTime) {
	   this.validTime = validTime;
   }
}
