package edu.bu.signstream.grepresentation.fields.glossField;

import edu.bu.signstream.common.util.vo.TimeInfo;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Item;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class Text { //extends  ChainedEvent {
	private String text = "";
	
	private TimeInfo startTimeInfo = new TimeInfo();
	private TimeInfo endTimeInfo = new TimeInfo();
			
	private boolean visible = true;
	private boolean selected = false;
	
	public Text(String text, int startCoord, int endCoord) {
		this.text = text;
		
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		int startMovieTime = segmentPanel.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTime(startCoord);
		int endMovieTime = segmentPanel.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTime(endCoord);
		startTimeInfo.setMovieTime(startMovieTime);
		endTimeInfo.setMovieTime(endMovieTime);
	}

	public Text(String text) {
		this.text = text;
	}
	
	public TimeInfo getStartTime() {
		return startTimeInfo;
	}
	
	public void setStartTime(int time) {
		startTimeInfo.setMovieTime(time);
	}
	
	public TimeInfo getEndTime() {
		return endTimeInfo;
	}
	
	public void setEndTime(int time) {
		endTimeInfo.setMovieTime(time);
	}

	public SS3Item getSS3Item() {
		SS3Item item = new SS3Item(text, startTimeInfo);
		item.setEndTimeInfo(endTimeInfo);
		item.setTextOnly(true);
		return item;		
	}
	
	public void setSelected(boolean selected) {
		this.selected = selected;
	}
	
	public boolean isSelected() {
		return selected;
	}

	public void setVisible(boolean visible) {
		this.visible = visible;
	}
	
	public boolean isVisible() {
		return visible;
	}
	
	public String getText() {
		return text;
	}

	public void setText(String text) {
		this.text = text;
	}

	public int getStartCoord() {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		return segmentPanel.getZoomer().getCoordinateTimeConvertor().convertTimeToCoordinate(startTimeInfo.getMovieTime());
	}

	public void setStartCoord(int startCoord) {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		int startMovieTime = segmentPanel.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTime(startCoord);
		startTimeInfo.setMovieTime(startMovieTime);
		
		if(getEndCoord() < startCoord) {
			endTimeInfo.setMovieTime(startMovieTime);
		}
	}

	public int getEndCoord() {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		return segmentPanel.getZoomer().getCoordinateTimeConvertor().convertTimeToCoordinate(endTimeInfo.getMovieTime());
	}

	public void setEndCoord(int endCoord) {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		int endMovieTime = segmentPanel.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTime(endCoord);
		endTimeInfo.setMovieTime(endMovieTime);
	}
}