package edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields;

import java.util.ArrayList;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.grepresentation.fields.glossField.GlossFieldWrapper;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.fields.nonManualField.GlossEntityProperties;

public class HandShapeFormBean {
	private SS3CodingScheme cs = null;
	private GlossFieldWrapper glsFieldWrapper = null;

	private boolean fingerspelledSelected = false;
	private boolean fingerspelledR = false;

	private boolean oneHandedSelected = false;
	private boolean oneHandedR = false;

	private char type;

	private ArrayList<HandShapeImage> slctDomHandShapeImages = new ArrayList<HandShapeImage>();
	private ArrayList<HandShapeImage> slctNdomHandShapeImages = new ArrayList<HandShapeImage>();
	
	private GlossEntityProperties properties;
	
	public void setGlossEntityProperties(GlossEntityProperties properties) {
		this.properties = properties;
	}
	
	public GlossEntityProperties getGlossEntityProperties() {
		return properties;
	}

	public SS3CodingScheme getSS3CodingScheme() {
		return cs;
	}

	public void setSS3CodingScheme(SS3CodingScheme cs) {
		this.cs = cs;
	}

	public boolean isRightHandSelected() {
		if (fingerspelledSelected && fingerspelledR) {
			return fingerspelledR;
		} else if (oneHandedSelected && oneHandedR) {
			return oneHandedR;
		}
		return false;
	}

	public void setSelectedDomHandShapeImages(
			ArrayList<HandShapeImage> handShapes) {
		this.slctDomHandShapeImages.clear();
		this.slctDomHandShapeImages.addAll(handShapes);
	}

	public void setSelectedNdomHandShapeImages(
			ArrayList<HandShapeImage> handShapes) {
		this.slctNdomHandShapeImages.clear();
		this.slctNdomHandShapeImages.addAll(handShapes);
	}

	public ArrayList<HandShapeImage> getSelectedDomHandShapeImages() {
		return slctDomHandShapeImages;
	}

	public ArrayList<HandShapeImage> getSelectedNdomHandShapeImages() {
		return slctNdomHandShapeImages;
	}

	/**
	 * @param b
	 */
	public void setFingerspelledR(boolean b) {
		fingerspelledR = b;
	}

	/**
	 * @param b
	 */
	public void setFingerspelledSelected(boolean b) {
		fingerspelledSelected = b;
	}

	/**
	 * @param b
	 */
	public void setOneHandedR(boolean b) {
		oneHandedR = b;
	}

	/**
	 * @param b
	 */
	public void setOneHandedSelected(boolean b) {
		oneHandedSelected = b;
	}

	/**
	 * @param c
	 */
	public void setType(char c) {
		type = c;
	}

	/**
	 * @return
	 */
	public char getType() {
		return type;
	}

	/**
	 * @return
	 */
	public GlossFieldWrapper getGlsFieldWrapper() {
		return glsFieldWrapper;
	}

	/**
	 * @param wrapper
	 */
	public void setGlsFieldWrapper(GlossFieldWrapper wrapper) {
		glsFieldWrapper = wrapper;
	}
}
