package edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JDialog;

import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEventsEntity;
import edu.bu.signstream.grepresentation.listener.WeakWindowListener;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.fields.glossField.GlossFieldWrapper;
import edu.bu.signstream.grepresentation.view.GlossNRelatedView;
import edu.bu.signstream.ui.ConfirmationDialog;
import edu.bu.signstream.ui.SignStreamDialogInterface;

public class MorphologicalPhonologicalInfoDialog extends JDialog implements
		WindowListener, SignStreamDialogInterface {

	private static final long serialVersionUID = 1L;

	private AssociatedFieldsPanel panel = null;

	public MorphologicalPhonologicalInfoDialog(GlossFieldWrapper wrapper, GlossNRelatedView view) {
		super(SS3Singleton.getSignStreamApplication(), "Morph-Phon Info");
		super.setLocationRelativeTo(SS3Singleton.getSignStreamApplication());
		panel = new AssociatedFieldsPanel(wrapper, view, this);

		addWindowListener(new WeakWindowListener(this, this));

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout(150, 150));
		contentPane.add(panel, BorderLayout.CENTER);

		this.pack();		
	}
	
	public void update(GlossFieldWrapper wrapper, GlossNRelatedView view) {
		panel.update(wrapper, view);
	}

	@Override
	public void windowClosing(WindowEvent e) {
		boolean isChanged = panel.isChanged();

		if (isChanged) {
			ConfirmationDialog dialog = new ConfirmationDialog(this);
			dialog.setLocationRelativeTo(this);
			dialog.setModal(true);
			dialog.setVisible(true);
		} else {
			setVisible(false);
		}
	}

	@Override
	public void saveChanges() {
		panel.saveChanges();
	}

	@Override
	public void discardChanges() {
		// dispose();
		setVisible(false);
	}

	@Override
	public void windowClosed(WindowEvent e) {
		// This will only be seen on standard output.
		// displayMessage("WindowListener method called: windowClosed.");
	}

	@Override
	public void windowOpened(WindowEvent e) {
		// displayMessage("WindowListener method called: windowOpened.");
	}

	@Override
	public void windowIconified(WindowEvent e) {
		// displayMessage("WindowListener method called: windowIconified.");
	}

	@Override
	public void windowDeiconified(WindowEvent e) {
		// displayMessage("WindowListener method called: windowDeiconified.");
	}

	@Override
	public void windowActivated(WindowEvent e) {
		// displayMessage("WindowListener method called: windowActivated.");
	}

	@Override
	public void windowDeactivated(WindowEvent e) {
		// displayMessage("WindowListener method called: windowDeactivated.");
	}

	public GlossChainedEventsEntity getCurrentGlossEntity() {
		return panel.getCurrentGlossEntity();
	}

	public AssociatedFieldsPanel getAssociatedFieldsPanel() {
		return panel;
	}
}
