package edu.bu.signstream.grepresentation.fields.lTranslationField;

import java.util.ArrayList;

import edu.bu.signstream.common.util.vo.Track;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Entity;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Item;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Track;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEvent;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEventsEntityCollection;
import edu.bu.signstream.grepresentation.fields.glossField.GlossField;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsCollection;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class LiteraltranslationField extends GlossField {
   public LiteraltranslationField(
      Track track,
      SignStreamSegmentPanel segmentPanel, PresentationField parentField) {
      super(track, segmentPanel, parentField);
   }

   public LiteraltranslationField(SignStreamSegmentPanel segmentPanel, PresentationField parentField) {
      super(new SS3Track(), segmentPanel, parentField);
   }

   public LiteraltranslationField(
      SS3Track ss3track,
      SignStreamSegmentPanel segmentPanel, PresentationField parentField) {
      super(ss3track, segmentPanel, parentField);
      createTrackEntity(ss3track);
   }


   private void createTrackEntity(SS3Track track) {
      ArrayList chainedEvents = new ArrayList();
      ArrayList entities = track.getEntities();

      for (int j = 0; j < entities.size(); j++) {
         SS3Entity entity = (SS3Entity) entities.get(j);
         ChainedEventsCollection collection = new ChainedEventsCollection();

         ArrayList items = entity.getItemsAsList();
         for (int i = 0; i < items.size(); i++) {
            SS3Item item = (SS3Item) items.get(i);
            // String id = item.getId();

            GlossChainedEvent event = new GlossChainedEvent(item, segmentPanel);
            collection.setTextValueEvent(event);
         }

         LiteralTranslationEntity lEntity =
            new LiteralTranslationEntity(
               collection,
               track.getId(),
               segmentPanel, this);

         lEntity.setID(entity.getID());
         lEntity.setRefEntityId(entity.getRefEntityId());
         lEntity.setParentEntity((PresentationEventsEntity) getParentField().getEntity(entity.getParentEntityID()));
         chainedEvents.add(lEntity);
      }
      GlossChainedEventsEntityCollection collection =
         new GlossChainedEventsEntityCollection(chainedEvents, segmentPanel);
   }

   @Override
public void addChainedEventEntity(ChainedEventsEntity entity) {
      LiteralTranslationEntity lEntity =
         new LiteralTranslationEntity(
            entity.getChainedEventsCollection(),
            getFieldID(),
            segmentPanel, this);
      lEntity.determineParentEntity();

      //collection.addEntity(lEntity);
   }
}
