package edu.bu.signstream.grepresentation.fields.locationField;

import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;

import java.awt.*;
import java.util.ArrayList;

public class LocationEntityCollection {
    private ArrayList<LocationEntity> entities;

    public LocationEntityCollection(ArrayList<LocationEntity> entities) {
        this.entities = entities;
    }

    public EventsEntity getEntity(String entityID) {
        for (int i = 0; i < entities.size(); i++) {
            LocationEntity entity = entities.get(i);
            if (entity.getID().equals(entityID))
                return entity;
        }
        return null;
    }

    public EventsEntity getEntityWithRefID(String refEntityId) {
        for (int i = 0; i < entities.size(); i++) {
            LocationEntity entity = entities.get(i);
            if (refEntityId.equalsIgnoreCase(entity.getRefEntityId()))
                return entity;
        }
        return null;
    }

    public int size() {
        return entities.size();
    }

    public void deleteEntity(LocationEntity entity) {
        entities.remove(entity);
    }

    public ArrayList<LocationEntity> getEntities() {
        return entities;
    }


    public void unselect() {
        for (int i = 0; i < entities.size(); i++) {
            LocationEntity entity = entities.get(i);
            entity.unselect();
        }
    }

    public void addEntity(LocationEntity entity) {
        this.entities.add(entity);
    }

    public LocationEntity getSelectedEntity() {
        for (int i = 0; i < entities.size(); i++) {
            LocationEntity entity = entities.get(i);

            if (entity.getSelectedEvent() != null)
                return entity;
        }
        return null;
    }

    public LocationEvent getEventAt(int x) {
        for (LocationEntity entity : entities) {
            LocationEvent event = (LocationEvent) entity.getEventAt(x);
            if (event != null) {
                return event;
            }
        }
        return null;
    }

    public void paintEntities(Graphics2D g2d, double Y, Font font) {
        for (int j = 0; j < entities.size(); j++) {
            LocationEntity entity = entities.get(j);
            entity.paint(g2d, Y, font);
        }
    }
}
