package edu.bu.signstream.grepresentation.fields.locationField;

import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

import java.util.ArrayList;
import java.util.Arrays;

public class LocationEventsCollection {

    private ArrayList<LocationEvent> events = new ArrayList<LocationEvent>();

    public LocationEventsCollection() {
        resetAll();
    }

    public void addEvent(LocationEvent event) {
        events.add(event);
    }

    public LocationEvent getEvent(int idx) {
        return events.get(idx);
    }

    public LocationEvent getFirstEvent() {
        return events.get(0);
    }

    public LocationEvent getLastEvent() {
        return events.get(events.size() - 1);
    }

    public boolean adjustEntity(int startTime, int endTime) {
        LocationEvent fEvent = getFirstEvent();
        LocationEvent lEvent = getLastEvent();

        if (fEvent == null || lEvent == null)
            return false;

        fEvent.getStartTimeInfo().setMovieTime(startTime);
        lEvent.getEndTimeInfo().setMovieTime(endTime);
        return true;
    }

    public void resetAll() {
        events.clear();
    }

    public boolean deleteAll() {
        resetAll();
        return true;
    }

    public ArrayList<LocationEvent> getEvents() {
        return new ArrayList<LocationEvent>(events);
    }

    public int size() {
        return events.size();
    }
}
