package edu.bu.signstream.grepresentation.fields.locationField;

import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.FieldWrapper;
import edu.bu.signstream.grepresentation.fields.glossField.GlossFieldWrapper;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.AssociatedFieldsPanel;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.MorphologicalPhonologicalInfoDialog;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEvent;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.GlossNRelatedView;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

import javax.swing.*;
import java.awt.*;

public class LocationFieldWrapper extends FieldWrapper {

    private LocationField lField;

    public LocationFieldWrapper(LocationField field, SignStreamSegmentPanel segmentPanel) {
        super(field, segmentPanel);
        this.lField = field;
    }

    @Override
    public EventsEntity getEntityAt(int entityAt) {
        return lField.getEntityAt(entityAt);
    }

    @Override
    public void highlight(boolean highlight, String refID) {
        field.highlight(highlight, refID);
    }

    @Override
    public void addEventsEntity(EventsEntity entity) {
        lField.addEventsEntity(entity);
    }

    @Override
    public boolean contains(int Y) {
        return field.contains(Y);
    }

    @Override
    public void mouseClicked(Point point, JPanel panel) {
    }

    @Override
    public void mouseClickedAlt(Point point) {
    }

    @Override
    public void mousePressedAlt(Point point, JPanel panel) {
    }

    @Override
    public void mouseRightClicked(Point point) {
    }

    @Override
    public void mouseLeftClicked(Point point) {
    }

    @Override
    public void mouseReleased(Point point, JPanel panel) {
    }

    @Override
    public void mouseDblLeftClicked(Point point, JPanel panel) {
    }

    @Override
    public void mouseDblRightClicked(Point point, JPanel panel) {
    }

    @Override
    public void mouseMoved(Point point, JPanel panel) {
        LocationEntity entity = (LocationEntity) lField.getEntityAt(point.x);
        if (entity != null) {
            panel.setToolTipText(entity.getToolTipText(point.x));
        } else {
            panel.setToolTipText("");
        }
    }

    @Override
    public void mouseDragged(Point point, JPanel panel) {
    }

    @Override
    public void unselectAll() {
        field.unselect();
    }

    @Override
    public void mouseHoldReleased(Point point, JPanel panel) {
    }
}
