package edu.bu.signstream.grepresentation.fields.nonManualField;

import edu.bu.signstream.common.util.UIPalette;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.UtteranceView;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.main.ToolBarPanels;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolbarCommons;

import javax.swing.*;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;
import java.awt.*;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

public class NonManualFreeTextFieldWrapper extends NonManualFieldWrapper {

    public NonManualFreeTextFieldWrapper(NonManualField field, SignStreamSegmentPanel segmentPanel) {
        super(field, segmentPanel);
    }

    @Override
    public void mousePressedAlt(final Point point, JPanel panel) {
        EventsEntity entityAt = nmField.getEntityAt(point.x);
        if (entityAt != null) {
            return;
        }

        final JPopupMenu popup = new JPopupMenu();

        int width = 250;
        int height = 17;

        final JTextField labelTextField = new JTextField();

        labelTextField.setPreferredSize(new Dimension(width, height));
        labelTextField.setBounds(new Rectangle(0, 0, 0, 0));
        labelTextField.setBackground(UIPalette.getBackground());
        labelTextField.setForeground(Color.black);
        labelTextField.setSize(5, 10);
        popup.setBounds(0, 0, 0, 0);
        popup.setBorder(BorderFactory.createEmptyBorder());
        popup.setBackground(UIPalette.getBackground());
        popup.add(labelTextField);

        popup.addPopupMenuListener(new PopupMenuListener() {
            @Override
            public void popupMenuWillBecomeVisible(PopupMenuEvent e) {
            }

            @Override
            public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
                onExit();
            }

            @Override
            public void popupMenuCanceled(PopupMenuEvent e) {
                onExit();
            }

            public void onExit() {
                handleNewFreeTextEvent(labelTextField.getText(), point);
            }
        });

        SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                labelTextField.requestFocus();
            }
        });

        labelTextField.addKeyListener(new KeyAdapter() {
            @Override
            public void keyReleased(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    popup.setVisible(false);
                    segmentPanel.repaint();
                }
            }
        });

        UtteranceView utteranceView = segmentPanel.getUtteranceView();

        int txtWidthL = utteranceView.getWidht() + utteranceView.getVisiblePoint().x;
        int txtWidth = txtWidthL - point.x;
        Dimension d = popup.getPreferredSize();
        d.setSize(txtWidth, d.getHeight());
        popup.setPreferredSize(d);

        int y = field.getY() - 11;

        SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);

        popup.show(panel, point.x, y);
        popup.setVisible(true);

        labelTextField.addFocusListener(new FocusListener() {
            @Override
            public void focusGained(FocusEvent e) {
            }

            @Override
            public void focusLost(FocusEvent e) {
                popup.setVisible(false);
            }
        });
    }

    private void handleNewFreeTextEvent(String text, Point point) {
        if (!text.trim().isEmpty()) {
            NewChainedEvent newChainedEvent = new NewChainedEvent(point.x, segmentPanel);

            ChainedEventsCollection collection = new ChainedEventsCollection();
            ChainedEvent event = new ChainedEvent(segmentPanel);
            event.getStartTimeInfo().setMovieTime(newChainedEvent.getStartTime());
            event.getEndTimeInfo().setMovieTime(newChainedEvent.getEndTime());
            event.setText(text);

            collection.setValueEvent(event);
            event.select();

            ChainedEventsEntity entity = new ChainedEventsEntity(collection, segmentPanel, nmField);
            entity.determineParentEntity();
            entity.select();

            nmField.addChainedEventEntity(entity);

            ToolBarPanels panels = segmentPanel.getToolBarPanels();
            MediaToolBar mediaTb = panels.getMediaToolBar();
            mediaTb.selectEvent(event, entity, nmField);
        }
    }
}