package edu.bu.signstream.grepresentation.fields.partOfSpeechField;

import java.util.*;
import edu.bu.signstream.grepresentation.fields.*;
import edu.bu.signstream.grepresentation.fields.nonManualField.*;

public class SyntacticGroup {
	private ArrayList entities = new ArrayList();
	private String label = "";

	public void setEntities(ArrayList entities) {
		this.entities = entities;
	}
	
	public void addEntity(EventsEntity entity) {
		entities.add(entity);
	}

	public int getStartTimeCoordinate() {
		int startCoord = 0;
		if (entities.size() > 0) {
			ChainedEventsEntity entity = (ChainedEventsEntity) entities.get(0);
			startCoord = entity.getStartTimeCoordinate();
		}

		for (int i = 1; i < entities.size(); i++) {
			ChainedEventsEntity entity = (ChainedEventsEntity) entities.get(i);
			int s = entity.getStartTimeCoordinate();
			startCoord = s < startCoord ? s : startCoord;
		}

		return startCoord;
	}

	public int getEndTimeCoordinate() {
		int endCoord = 0;
		if (entities.size() > 0) {
			ChainedEventsEntity entity = (ChainedEventsEntity) entities.get(0);
			endCoord = entity.getEndTimeCoordinate();
		}

		for (int i = 1; i < entities.size(); i++) {
			ChainedEventsEntity entity = (ChainedEventsEntity) entities.get(i);
			int s = entity.getEndTimeCoordinate();
			endCoord = s > endCoord ? s : endCoord;
		}

		return endCoord;
	}

	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

//	public void setLabelStartCoord(int lblStartCoord) {
//		this.lblStartCoord = lblStartCoord;
//	}
//
//	public void setLabelEndCoord(int lblEndCoord) {
//		this.lblEndCoord = lblEndCoord;
//	}
//
//	public int getLabelStartCoord() {
//		return lblStartCoord;
//	}
//
//	public int getLabelEndCoord() {
//		return lblEndCoord;
//	}
	
	public boolean contains(int x) {
		int endCoord = getEndTimeCoordinate();
		return endCoord+5 <= x && x <= endCoord+20;
	}
	
	public ArrayList getAvailableSGLabels() {
		ArrayList list = new ArrayList();
		list.add("+ VERB");
		list.add("VERB");
		list.add("- VERB");
		return list;
	}
}
