package edu.bu.signstream.grepresentation.fields.rightLeftField;

import java.awt.Point;

import javax.swing.JPanel;

import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.FieldWrapper;
import edu.bu.signstream.grepresentation.fields.nonManualField.NonManualField;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.main.ToolBarPanels;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;

public class RightLeftHandFieldWrapper extends FieldWrapper {

	public RightLeftHandFieldWrapper(NonManualField rlField,
			SignStreamSegmentPanel segmentPanel) {
		super(rlField, segmentPanel);
	}

	public RightLeftHandFieldWrapper(SignStreamSegmentPanel segmentPanel, PresentationField parentField) {
		super(new RightLeftHandField(segmentPanel, parentField), segmentPanel);
	}

	@Override
	public void addEventsEntity(EventsEntity entity) {
		getField().addEventsEntity(entity);
	}

	@Override
	public boolean contains(int Y) {
		return getField().contains(Y);
	}

	@Override
	public void highlight(boolean highlight, String refID) {
	}

	@Override
	public void mouseClicked(Point point, JPanel panel) {		
		ToolBarPanels panels = segmentPanel.getToolBarPanels();
		MediaToolBar mediaTb = panels.getMediaToolBar();

		EventsEntity entity = getField().getEntityAt(point.x);
		Event event = getField().getEventAt(point.x);
		if (event != null) {
			event.select();
			mediaTb.selectEvent(event, entity, getField());
		}
	}

	@Override
	public void mouseClickedAlt(Point point) {
	}

	@Override
	public void mousePressedAlt(Point point, JPanel panel) {
	}

	@Override
	public void mouseRightClicked(Point point) {
	}

	@Override
	public void mouseLeftClicked(Point point) {
	}

	@Override
	public void mouseReleased(Point point, JPanel panel) {
	}

	@Override
	public void mouseDblLeftClicked(Point point, JPanel panel) {
	}

	@Override
	public void mouseDblRightClicked(Point point, JPanel panel) {
	}

	@Override
	public void mouseMoved(Point point, JPanel panel) {
	}

	@Override
	public void mouseDragged(Point point, JPanel panel) {
	}

	@Override
	public void unselectAll() {
	    field.unselect();
	    for (FieldWrapper wrapper : dependentWrappers) {
	         wrapper.unselectAll();
	    }
	}

	@Override
	public void mouseHoldReleased(Point point, JPanel panel) {
	}
}
