package edu.bu.signstream.grepresentation.fields.signTypeField;

import edu.bu.signstream.common.util.vo.TimeInfo;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Entity;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Item;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.Field;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEventsEntity;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

import java.awt.*;
import java.util.ArrayList;

public class SignTypeEntity extends EventsEntity {

    private SignTypeEvent event;

    private GlossChainedEventsEntity refDomGlossEntity;

    public SignTypeEntity(SignTypeEvent event, SignStreamSegmentPanel segmentPanel, Field field) {
        super(segmentPanel, field);
        this.event = event;
    }

    public void setRefGlossEntity(GlossChainedEventsEntity refDomGlossEntity) {
        this.refDomGlossEntity = refDomGlossEntity;
    }

    @Override
    public SS3Entity getSS3Entity() {
        SS3Entity ss3entity = new SS3Entity();
        ss3entity.addItem(new SS3Item(getEvent()));
        ss3entity.setID(getID());
        return ss3entity;
    }

    public SignTypeEvent getEvent() {
        return event;
    }

    @Override
    public Event getFirstEvent() {
        return event;
    }

    @Override
    public Event getLastEvent() {
        return event;
    }

    @Override
    public boolean selectEntityIfEventSelected() {
        return false;
    }

    @Override
    public boolean selectEventIfEntitySelected() {
        return false;
    }

    @Override
    public TimeInfo getStartTimeInfo() {
        return event.getStartTimeInfo();
    }

    @Override
    public TimeInfo getEndTimeInfo() {
        return event.getEndTimeInfo();
    }

    @Override
    public void setStartTimeInfo(TimeInfo startTimeInfo) {
        event.setStartTimeInfo(startTimeInfo);
    }

    @Override
    public void setEndTimeInfo(TimeInfo endTimeInfo) {
        event.setEndTimeInfo(endTimeInfo);
    }

    public void updateTimes() {
        if (refDomGlossEntity != null) {
            setStartTimeInfo(refDomGlossEntity.getStartTimeInfo().cloneTimeInfo());
            setEndTimeInfo(refDomGlossEntity.getEndTimeInfo().cloneTimeInfo());
        }
    }

    @Override
    public boolean select() {
        return false;
    }

    @Override
    public boolean unselect() {
        return false;
    }

    @Override
    public boolean adjustEntity(int x1, int x2) {
        return false;
    }

    @Override
    public Event getSelectedEvent() {
        return null;
    }

    @Override
    public void reset() {

    }

    @Override
    public boolean delete() {
        return false;
    }

    @Override
    public Event getEventAt(int x) {
        return null;
    }

    @Override
    public ArrayList<String> getEventsToAdd() {
        return null;
    }

    @Override
    public String getToolTipText(int x) {
        return null;
    }

    @Override
    public boolean selectEvent(int x) {
        return false;
    }

    @Override
    public void paint(Graphics2D g2d, double Y, Font font) {
        int y = (int) Y;
        g2d.setFont(font);
        g2d.setColor(Color.BLACK);

        SignType signType = event.getSignType();
        if (signType != null && signType != SignType.NONE) {
            String signTypeLabel = signType.getLabel();
            if (event.isNameSign()) {
                signTypeLabel = "ns-" + signTypeLabel;
            }
            int x1 = event.getStartTimeCoordinate();
            int x2 = event.getEndTimeCoordinate();
            int strWidth = g2d.getFontMetrics().stringWidth(signTypeLabel);

            g2d.drawString(signTypeLabel, (x1 + x2 - strWidth) / 2, y);
            g2d.drawLine(x1, y + 1, x2, y + 1);
            g2d.drawLine(x1, y + 2, x2, y + 2);
            g2d.drawLine(x1, y - 1, x1, y + 2);
            g2d.drawLine(x2, y - 1, x2, y + 2);
        }
    }
}
