package edu.bu.signstream.grepresentation.fields.signTypeField;

import edu.bu.signstream.common.util.vo.TimeInfo;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Item;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

import java.awt.*;

public class SignTypeEvent implements Event {

    private String id;

    private TimeInfo startTimeInfo, endTimeInfo;

    private SignType signType;
    private boolean nameSign;

    private SignStreamSegmentPanel segmentPanel;

    public SignTypeEvent(SignStreamSegmentPanel segmentPanel, TimeInfo startTimeInfo, TimeInfo endTimeInfo) {
        this.segmentPanel = segmentPanel;
        setStartTimeInfo(startTimeInfo);
        setEndTimeInfo(endTimeInfo);
    }

    public SignTypeEvent(SignStreamSegmentPanel segmentPanel, SS3Item item) {
        this(segmentPanel, item.getStartTimeInfo(), item.getEndTimeInfo());
    }

    public SignType getSignType() {
        return signType;
    }

    public void setSignType(SignType signType) {
        this.signType = signType;
    }

    public boolean isNameSign() {
        return nameSign;
    }

    public void setNameSign(boolean nameSign) {
        this.nameSign = nameSign;
    }

    @Override
    public TimeInfo getStartTimeInfo() {
        return startTimeInfo;
    }

    @Override
    public TimeInfo getEndTimeInfo() {
        return endTimeInfo;
    }

    @Override
    public void setStartTimeInfo(TimeInfo startTimeInfo) {
        this.startTimeInfo = startTimeInfo;
    }

    @Override
    public void setEndTimeInfo(TimeInfo endTimeInfo) {
        this.endTimeInfo = endTimeInfo;
    }

    @Override
    public int getStartTimeCoordinate() {
        return segmentPanel.getZoomer().getCoordinateTimeConvertor()
                .convertTimeToCoordinate(startTimeInfo.getMovieTime());
    }

    @Override
    public int getEndTimeCoordinate() {
        return segmentPanel.getZoomer().getCoordinateTimeConvertor()
                .convertTimeToCoordinate(endTimeInfo.getMovieTime());
    }

    @Override
    public void setStartTimeCoordinate(int coord) {
        int newMovieTime = segmentPanel.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTime(coord);
        startTimeInfo.setMovieTime(newMovieTime);
    }

    @Override
    public void setEndTimeCoordinate(int coord) {
        int newMovieTime = segmentPanel.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTime(coord);
        endTimeInfo.setMovieTime(newMovieTime);
    }

    @Override
    public String getToolTipText() {
        return "Sign Type: " + signType.name().toLowerCase();
    }

    @Override
    public boolean select() {
        return false;
    }

    @Override
    public boolean unselect() {
        return false;
    }

    @Override
    public void highlight() {}

    @Override
    public void unhighlight() {}

    @Override
    public boolean isSelected() {
        return false;
    }

    @Override
    public boolean isHighlighted() {
        return false;
    }

    @Override
    public void setColor(Color color) {}

    @Override
    public Color getColor() { return null; }

    @Override
    public String getID() {
        return id;
    }

    @Override
    public void setID(String id) {
        this.id = id;
    }
}
