package edu.bu.signstream.grepresentation.listener;

import edu.bu.signstream.ui.SS3SignStreamApplication;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.lang.ref.WeakReference;
import java.lang.reflect.Method;
import java.util.logging.Level;

public class WeakMouseListener implements MouseListener {

	private WeakReference<MouseListener> weakListenerReference;
	private Object source;

	public WeakMouseListener(MouseListener listener, Object source) {
		this.weakListenerReference = new WeakReference<MouseListener>(listener);
		this.source = source;
	}

	public void mouseClicked(MouseEvent mouseEvent) {
		MouseListener mouseListener = (MouseListener) this.weakListenerReference
				.get();
		if (mouseListener == null) {
			this.removeListener();
		} else {
			mouseListener.mouseClicked(mouseEvent);
		}
	}

	public void mousePressed(MouseEvent mouseEvent) {
		MouseListener mouseListener = (MouseListener) this.weakListenerReference
				.get();
		if (mouseListener == null) {
			this.removeListener();
		} else {
			mouseListener.mousePressed(mouseEvent);
		}
	}

	public void mouseReleased(MouseEvent mouseEvent) {
		MouseListener mouseListener = (MouseListener) this.weakListenerReference
				.get();
		if (mouseListener == null) {
			this.removeListener();
		} else {
			mouseListener.mouseReleased(mouseEvent);
		}
	}

	public void mouseEntered(MouseEvent mouseEvent) {
		MouseListener mouseListener = (MouseListener) this.weakListenerReference
				.get();
		if (mouseListener == null) {
			this.removeListener();
		} else {
			mouseListener.mouseEntered(mouseEvent);
		}
	}

	public void mouseExited(MouseEvent mouseEvent) {
		MouseListener mouseListener = (MouseListener) this.weakListenerReference
				.get();
		if (mouseListener == null) {
			this.removeListener();
		} else {
			mouseListener.mouseExited(mouseEvent);
		}
	}

	private void removeListener() {
		try {
			Method method = source.getClass().getMethod("removeMouseListener",
					new Class[] { MouseListener.class });
			method.invoke(source, new Object[] { this });
		} catch (Exception ex) {
			ex.printStackTrace();
			SS3SignStreamApplication.logger.log(Level.SEVERE, "Exception", ex);
		}
	}
}
