package edu.bu.signstream.grepresentation.view;

import java.util.ArrayList;

public class RootLabelObject {

   private LabelObject nonManuelLabelObject = new LabelObject();
   private LabelObject glossNRelatedLabelObject = new LabelObject();
   private LabelObject presentationLabelObject = new LabelObject();
   private LabelObject graphLabelObject = new LabelObject();
   
   public RootLabelObject() {}

   public LabelObject getNonManuelLabelObject() {
      return nonManuelLabelObject;
   }

   public void setNonManuelLabelObject(LabelObject object) {
      nonManuelLabelObject = object;
   }

   public ArrayList<LabelObject> getAllLabelObjects() {
      if (presentationLabelObject != null
         && presentationLabelObject.getAllChildren().size() > 0) {
         return presentationLabelObject.getAllChildren();
      } else {
         try {
            
        	 	ArrayList<LabelObject> list = graphLabelObject.getAllChildren();
            list.addAll(nonManuelLabelObject.getAllChildren());
            list.addAll(glossNRelatedLabelObject.getAllChildren());

            return list;
         } catch (NullPointerException ex) {
            return new ArrayList<LabelObject>();
         }
      }
   }

   public LabelObject getGlossNRelatedLabelObject() {
      return glossNRelatedLabelObject;
   }

   public LabelObject getPresentationLabelObject() {
      return presentationLabelObject;
   }
   
   public LabelObject getGraphLabelObject() {
	      return graphLabelObject;
   }

   public void setGlossNRelatedLabelObject(LabelObject object) {
      glossNRelatedLabelObject = object;
   }

   public void setPresentationLabelObject(LabelObject object) {
      presentationLabelObject = object;
   }
   
   public void setGraphLabelObject(LabelObject obj) {
	   graphLabelObject = obj;
   }
}
