package edu.bu.signstream.grepresentation.view;

import java.awt.Component;
import java.awt.Dimension;

import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JSplitPane;

import edu.bu.signstream.common.util.SegmentGraphReprUtil;
import edu.bu.signstream.common.util.vo.Palette;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class ScrollBarView extends JPanel {

	private static final long serialVersionUID = 1L;
	
	   protected JScrollBar pictureScrollBar;

	   private SignStreamSegmentPanel panel;
	   private JPanel blankPanel = null;
	   
	   private JSplitPane sp;

	   public ScrollBarView(
	      SignStreamSegmentPanel panel) {
	      this.panel = panel;

	      createUI();
	   }

	   public void createUI() {
		   setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		   
		   sp = new JSplitPane();

		   blankPanel = new JPanel();
		   blankPanel.setBackground(Palette.BACKGROUND_COLOR);
		   blankPanel.setPreferredSize(new Dimension(
				   SegmentGraphReprUtil.UTTERANCE_VIEW_LABEL_PANEL_WIDTH, 
				   SegmentGraphReprUtil.UTTERANCE_VIEW_HEADER_FOOTER_HEIGHT));  	      
		   blankPanel.setMinimumSize(new Dimension(
				   SegmentGraphReprUtil.UTTERANCE_VIEW_LABEL_PANEL_WIDTH, 
				   SegmentGraphReprUtil.UTTERANCE_VIEW_HEADER_FOOTER_HEIGHT));  
		   //add(blankPanel);
		   
		   pictureScrollBar = new JScrollBar(JScrollBar.HORIZONTAL);
		   pictureScrollBar.setPreferredSize(new Dimension(
				   SegmentGraphReprUtil.UTTERANCE_VIEW_GRAPH_PANEL_WIDTH, 
				   SegmentGraphReprUtil.UTTERANCE_VIEW_HEADER_FOOTER_HEIGHT));
		   pictureScrollBar.setMinimumSize(new Dimension(
				   SegmentGraphReprUtil.UTTERANCE_VIEW_GRAPH_PANEL_WIDTH, 
				   SegmentGraphReprUtil.UTTERANCE_VIEW_HEADER_FOOTER_HEIGHT));
		   //add(pictureScrollBar);
		   
		   sp.setLeftComponent(blankPanel);
		   sp.setRightComponent(pictureScrollBar);
		   
		   add(sp);
	   }

	   public JScrollBar getJScrollBar() {
		   return pictureScrollBar;
	   }
	   
	   public JSplitPane getSplitPane() {
		   return sp;
	   }
	}
