package edu.bu.signstream.grepresentation.view;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import edu.bu.signstream.common.util.vo.ss3.db.SS3GlossWindowSegment;
import edu.bu.signstream.common.util.vo.ss3.db.SS3TemporalPartition;
import edu.bu.signstream.grepresentation.fields.FieldWrapper;
import edu.bu.signstream.grepresentation.fields.FieldWrappersCollection;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationFieldWrapper;
import edu.bu.signstream.grepresentation.fields.presentation.SegmentFieldWrapper;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.main.Zoomer;

public class UpperLeftCorner extends Corner {
	private static final long serialVersionUID = 1L;

	public static final int SLIDER_MAX = 1000000000;

	JSlider zoomInOut = new JSlider();

	public UpperLeftCorner(final SignStreamSegmentPanel segmentPanel) {
		
		Zoomer zoomer = segmentPanel.getZoomer();

		zoomInOut.setMajorTickSpacing(SLIDER_MAX / 5);
		zoomInOut.setMinorTickSpacing(SLIDER_MAX / 20);
		zoomInOut.setPaintTicks(true);
		zoomInOut.setMaximum(SLIDER_MAX);
		zoomInOut.setMinimum(0);

		zoomInOut.getInputMap().put(KeyStroke.getKeyStroke("LEFT"), "none");
		zoomInOut.getInputMap().put(KeyStroke.getKeyStroke("RIGHT"), "none");

		zoomInOut.getInputMap().put(KeyStroke.getKeyStroke("UP"), "utteranceUp");
		zoomInOut.getInputMap().put(KeyStroke.getKeyStroke("DOWN"), "utteranceDown");
		zoomInOut.getActionMap().put("utteranceUp", new AbstractAction() {
			@Override
			public void actionPerformed(ActionEvent e) {
				moveUtteranceList(true);
			}
		});
		zoomInOut.getActionMap().put("utteranceDown", new AbstractAction() {
			@Override
			public void actionPerformed(ActionEvent e) {
				moveUtteranceList(false);
			}
		});

		zoomInOut.addKeyListener(SS3Singleton.getVideoControlKeyListener());

		zoomInOut.setValue((int)Math.round(segmentPanel.getZoomer().zoom() * SLIDER_MAX));
		zoomInOut.setPreferredSize(new Dimension(150, 30));
		zoomInOut.addChangeListener(new ChangeListener() {
			@Override
			public void stateChanged(ChangeEvent event) {
				double value = (double)zoomInOut.getValue() / SLIDER_MAX;
                if (segmentPanel.isUtteranceLoaded()) {
					segmentPanel.getUtteranceView().zoom(value);
				} else {
					segmentPanel.getDatabaseView().zoom(value);
				}
			}
		});

		setLayout(new BorderLayout());
		add(zoomInOut, BorderLayout.CENTER);
	}

	private void moveUtteranceList(boolean up) {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		if (segmentPanel.isUtteranceLoaded()) {
			SegmentControlPanel controlPanel = segmentPanel.getUtteranceView().getSegmentTemplate().getSegmentControlPanel();
			controlPanel.moveUtteranceListSelection(up);
		}
	}

	public void setValue(double value) {
		zoomInOut.setValue((int)Math.round(value * SLIDER_MAX));
	}

	public JSlider getZoomInOut() {
		return zoomInOut;
	}
}
