package edu.bu.signstream.grepresentation.view.main;

import java.awt.Point;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.ui.video.MultipleMovieController;

public class Slider {

	private int sliderPosition = 0;

	private boolean selected = false;

	public Slider() {}

	public void setSliderPositionCoordNoPanel(int sliderPosition) {
		this.sliderPosition = sliderPosition;

		MultipleMovieController controller = SS3Singleton.getVideoControlManager().getMultipleMovieController();

		int movieDuration = controller.getMovieDuration();
		int currentTime = controller.getCurrentTime();

		if(currentTime == movieDuration) {
			SS3Singleton.getVideoControlManager().moveSliderTo(MultipleMovieController.NUMBER_OF_SLIDER_TICKS);
		} else {
			double tt = movieDuration / MultipleMovieController.NUMBER_OF_SLIDER_TICKS;
			double sliderNewPosition = currentTime/tt;
			SS3Singleton.getVideoControlManager().moveSliderTo((int)sliderNewPosition);
		}
	}

	public void setSliderPositionCoord(int sliderPosition) {
		setSliderPositionCoordNoPanel(sliderPosition);
		//If slider moves, move screen so slider is visible.
		SignStreamSegmentPanel panel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		panel.setVisible(sliderPosition, sliderPosition, !panel.isUtteranceLoaded());
	}

	public void setSliderPositionTime(int time) {
		int coord = SS3Singleton.getVideoControlManager().getZoomer().getCoordinateTimeConvertor().convertTimeToCoordinate(time);
		setSliderPositionCoord(coord);
	}

	public void unselect() {
		selected = false;
	}
	
	public void setSliderPositionOnly(int sliderCoord) {
		this.sliderPosition = sliderCoord;
	}

	// dStartTime - time, not coordinate!!!
	public void setSliderPosition(int sliderCoord, boolean resetMovie) {
		setSliderPositionCoord(sliderCoord);
	}

	public void setSliderPosition(long ts) {
		int coord = SS3Singleton.getVideoControlManager().getZoomer().getCoordinateTimeConvertor().convertTimeToCoordinate((int)ts);
		this.sliderPosition = coord;
		SignStreamSegmentPanel panel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		panel.setVisible(sliderPosition, sliderPosition, !panel.isUtteranceLoaded());
	}

	public boolean isResizable(Point p) {
		int X = (int) p.getX();
		int Y = (int) p.getY();

		if (Y > 0 && Y < 20) {
			return isResizable(X);
		}
		return false;
	}

	public boolean isResizable(int X) {
		if (X < sliderPosition + 3 && X > sliderPosition - 3) {
			selected = true;
		} else {
			selected = false;
		}

		return selected;
	}

	public int getSliderPosition() {
		return sliderPosition;
	} 	
}
