package edu.bu.signstream.grepresentation.view.mediaControl;

import javax.swing.JTextField;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEvent;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class BaseListener {
	
	MediaToolBar bar;

	BaseListener(MediaToolBar bar) {
		this.bar = bar;
	}
	
	SignStreamSegmentPanel getSignStreamSegmentPanel() {
		SignStreamSegmentPanel panel = bar.getSignStreamsegmentPanel();

		if (panel == null)
			return panel;

		if (panel.getMultipleMovieController().getMovies().isEmpty()) {
			// no video files are loaded
			SS3Singleton.getErrorMessages().showErrorMessage(
					ErrorMessages.SELECT_VALID_VIDEO_FILE);
			return null;
		}
		
		MediaToolbarVideoController.stopPlayingVideo(panel);		
		return panel;
	}
	
	void movePanelToTime(SignStreamSegmentPanel panel, int time, JTextField field) {
		if(field != null) {
			field.setText(""+time);
		}
		panel.getMultipleMovieController().setCurrentTime(time);
		panel.getSlider().setSliderPositionTime(time);
		/*
		 * Note: no need to call panel.setVisible() here, because it is called via setSliderPositionTime() above via this flow:
		 * 	Slider.setSliderPositionTime(int)
		 * 		Slider.setSliderPositionCoord(int)
		 * 			setVisible(int, int, boolean)		// with both ints given as the *same* coord, converted from `time` above here
		 */
		panel.repaint();
	}

	void movePanelToUtterance(SignStreamSegmentPanel panel, PresentationEvent utterance, boolean start) {
		int toTime = start ? utterance.getStartTimeInfo().getMovieTime() : utterance.getEndTimeInfo().getMovieTime();
		int toCoord = start ? utterance.getStartTimeCoordinate() : utterance.getEndTimeCoordinate();
		panel.getMultipleMovieController().goToPacketTimeStamp(toTime);
		panel.getSlider().setSliderPositionCoordNoPanel(toCoord);
		panel.setUtteranceVisible(utterance, start);
		panel.repaint();
	}
}
