package edu.bu.signstream.grepresentation.view.mediaControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.Field;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public abstract class EndFrameListener extends BaseListener implements ActionListener {

	public EndFrameListener(MediaToolBar bar) {
		super(bar);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		SignStreamSegmentPanel panel = getSignStreamSegmentPanel();
		Field field = bar.getSelectedField();
		Event event = bar.getSelectedEvent();

		EventsEntity selectedEntity = bar.getSelectedEventsEntity();		
		
		if (selectedEntity == null)
			return;
		
		EventsEntity parentEntity = selectedEntity.getParentEntity();

		if (panel == null || event == null)
			return;

		int time = event.getEndTimeInfo().getMovieTime();
		int newTime = getNewTime(panel, event);

		if (field instanceof PresentationField
				|| event instanceof PresentationEventsEntity) {
			EventsEntity entity = bar.getSelectedEventsEntity();
			if (MediaToolbarCommons.isUpdatablePresentationEvent(entity)) {
				MediaToolbarCommons.setPresentationEventEndTime(newTime, event,
						entity, field, panel, bar.getEndTimeTextField());
			}
		} else {
			MediaToolbarCommons.setSelectedEventEndTime(newTime, event,
					parentEntity, bar);
			int updatedTime = event.getEndTimeInfo().getMovieTime();
			if (updatedTime != time) {
				movePanelToTime(panel, updatedTime, bar.getEndTimeTextField());
			}
		}
	}

	abstract int getNewTime(SignStreamSegmentPanel panel, Event event);
}
