package edu.bu.signstream.grepresentation.view.mediaControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.logging.Level;

import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.Field;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEvent;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.SegmentControlPanel;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.ui.SS3SignStreamApplication;

public class GoFirstFrameUtteranceListener extends BaseListener implements
		ActionListener {

	public GoFirstFrameUtteranceListener(MediaToolBar bar) {
		super(bar);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		//SS3SignStreamApplication.logger.log(Level.INFO, "Button clicked");
		SignStreamSegmentPanel panel = getSignStreamSegmentPanel();
		if (panel == null) {
			return;
		}

		if (panel.getUtteranceView() != null) {
			panel.getUtteranceView().setShowEndOnZoom(false);	
		}
		
		EventsEntity selectedEntity = bar.getSelectedEventsEntity();		
		Field parentField = bar.getCurrentParentField();
		PresentationEvent utterance = null;
		SegmentControlPanel segmentControlPanel = panel.getUtteranceView().getSelectedSegmentTemplate().getSegmentControlPanel();
		
		if (selectedEntity != null) {
			PresentationEventsEntity parentEntity = selectedEntity.getParentEntity();
			if (parentEntity != null) {
				utterance = parentEntity.getEvent();
			}
		} else if (parentField != null) {
			// slider coord
			int sliderPosition = bar.getSignStreamsegmentPanel().getSlider().getSliderPosition();
			PresentationEventsEntity parentEntity = (PresentationEventsEntity) parentField.getEventAt(sliderPosition);
			// if overlap with another utterance, use segmentControlPanel instead
			PresentationEventsEntity parentEntityCheck = (PresentationEventsEntity) parentField.getEventAt(sliderPosition+1);
			if (!parentEntity.equals(parentEntityCheck)) {
				if (segmentControlPanel != null) {
					utterance = segmentControlPanel.getSelectedUtterance().getEvent();
				} 
			} else {
				if (parentEntity != null) {
					utterance = parentEntity.getEvent();
				}
			}
		}

		if (utterance != null) {
			movePanelToUtterance(panel, utterance, true);
		} else if (!panel.isUtteranceLoaded()) {
			movePanelToTime(panel, 0, null);
			panel.getMultipleMovieController().goToFirstFrame();
		}
	}
}
