package edu.bu.signstream.grepresentation.view.mediaControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.Field;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEvent;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.view.SegmentControlPanel;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class GoLastFrameUtteranceListener extends BaseListener implements ActionListener {

	public GoLastFrameUtteranceListener(MediaToolBar bar) {
		super(bar);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		SignStreamSegmentPanel panel = getSignStreamSegmentPanel();
		if (panel == null) {
			return;
		}

		if (panel.getUtteranceView() != null) {
			panel.getUtteranceView().setShowEndOnZoom(true);
		}

		EventsEntity selectedEntity = bar.getSelectedEventsEntity();			
		Field parentField = bar.getCurrentParentField();
		PresentationEvent utterance = null;
		SegmentControlPanel segmentControlPanel = panel.getUtteranceView().getSelectedSegmentTemplate().getSegmentControlPanel();
		
		if (selectedEntity != null) {
			PresentationEventsEntity parentEntity = selectedEntity.getParentEntity();
			if (parentEntity != null) {
				utterance = parentEntity.getEvent();
			}
		} else if (parentField != null) {
			int sliderPosition = bar.getSignStreamsegmentPanel().getSlider().getSliderPosition();
			PresentationEventsEntity parentEntity = (PresentationEventsEntity) parentField.getEventAt(sliderPosition);
			// if overlap with another utterance, use segmentControlPanel instead
			PresentationEventsEntity parentEntityCheck = (PresentationEventsEntity) parentField.getEventAt(sliderPosition+1);
			if (!parentEntity.equals(parentEntityCheck)) {
				if (segmentControlPanel != null) {
					utterance = segmentControlPanel.getSelectedUtterance().getEvent();
				} 
			} else {
				if (parentEntity != null) {
					utterance = parentEntity.getEvent();
				}
			}
		} 
		
		if (utterance != null) {
			movePanelToUtterance(panel, utterance, false);
		} else if (!panel.isUtteranceLoaded()) {
			panel.getMultipleMovieController().goToLastFrame();
			movePanelToTime(panel, panel.getMultipleMovieController().getMovieDuration(), null);
		}
	}
	
	public void adjustMovieTime(SignStreamSegmentPanel panel) {
		if (panel != null && panel.getMultipleMovieController() != null) {
			int time = panel.getMultipleMovieController().getCurrentTime();

			if (time < 0)
				time = 0;

			int duration = panel.getMultipleMovieController().getMovieDuration();
			if (duration > 0 && time >= duration)
				return;
			panel.getMultipleMovieController().skipNumberOfFrames(1);
		}
	}
}
