package edu.bu.signstream.grepresentation.view.mediaControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.ui.video.VideoControlPanel;

public class PlayEntityListener implements ActionListener {

	private MediaToolBar bar;

	public PlayEntityListener(MediaToolBar bar) {
		this.bar = bar;
	}

	@Override
	public void actionPerformed(ActionEvent e) {

		SignStreamSegmentPanel segmentPanel = bar.getSignStreamsegmentPanel();

		if (segmentPanel != null) {

			MediaToolbarVideoController.stopPlayingVideo(segmentPanel);

			EventsEntity entity = bar.getSelectedEventsEntity();

			if (entity != null) {

				int startTime = entity.getStartTimeInfo().getMovieTime();
				int endTime = entity.getEndTimeInfo().getMovieTime();
				long packetDuration = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().getMultipleMovieController().getPacketDuration();
				endTime -= endTime % packetDuration;
				
				segmentPanel.getSlider().setSliderPositionTime(startTime);
				
				segmentPanel.repaint();

				ArrayList<VideoControlPanel> videoPanels = SS3Singleton
						.getVideoControlManager().getVideoControlPanels();
				
				for (VideoControlPanel videoPanel : videoPanels) {
					videoPanel.playMovie(false);
				}
				
				segmentPanel.getMultipleMovieController().playSegment(startTime, endTime, segmentPanel);
				segmentPanel.setVisible(entity);
			}
		}
	}
}
