package edu.bu.signstream.grepresentation.view.mediaControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class PlaySelectedEventListener implements ActionListener {

	private MediaToolBar bar;

	public PlaySelectedEventListener(MediaToolBar bar) {
		this.bar = bar;
	}

	@Override
	public void actionPerformed(ActionEvent e) {

		SignStreamSegmentPanel segmentPanel = bar.getSignStreamsegmentPanel();

		if (segmentPanel == null) {
			return;
		}

		MediaToolbarVideoController.stopPlayingVideo(segmentPanel);

		Event event = bar.getSelectedEvent();

		if (event != null) {
			
			int startTime = event.getStartTimeInfo().getMovieTime();
			int endTime = event.getEndTimeInfo().getMovieTime();
			long packetDuration = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().getMultipleMovieController().getPacketDuration();
			endTime -= endTime % packetDuration;
			
			segmentPanel.getSlider().setSliderPositionTime(startTime);
			segmentPanel.repaint();
			
			segmentPanel.setVisible(event);
			
			segmentPanel.getMultipleMovieController().playSegment(startTime, endTime, segmentPanel);
		} 
	}
}
