package edu.bu.signstream.grepresentation.view.signbank;

import java.util.ArrayList;
import java.util.HashMap;

public class SignBankMainGloss {
	
	private String mainGlossID = null;
	private String mainGlossLabel = null;
	private HashMap<String, SignBankVariant> variantsList = null;
	private String defaultVariantID = null;
	
	public SignBankMainGloss(String mainGlossID, String mainGlossLabel, String defaultVariantID) {
		this.mainGlossID = mainGlossID;
		this.mainGlossLabel = mainGlossLabel;
		this.defaultVariantID = defaultVariantID;
		this.variantsList = new HashMap<String, SignBankVariant>();
	}
	
	public String getMainGlossID() {
		return mainGlossID;
	}
	
	public String getMainGlossLabel() {
		return mainGlossLabel;
	}
	
	public SignBankVariant getVariantByLabel(String variantLabel) {
		return variantsList.get(variantLabel);
	}
	
	public SignBankVariant getDefaultVariant() {
		ArrayList<SignBankVariant> variants = (ArrayList<SignBankVariant>) variantsList.values();
		for (SignBankVariant variant: variants) {
			String variantID = variant.getVariantID();
			if (variantID != null && defaultVariantID == variantID) {
				return variant;
			}
		}
		
		return null;
	}
	
	public String getDefaultVariantID() {
		return defaultVariantID;
	}
	
	public void setDefaultVariantID(String defaultVariantID) {
		this.defaultVariantID = defaultVariantID;
	}
	
	/**
	 * Gets the list of SignBankVariant objects
	 * @return A HashMap from Variant Label -> Variant
	 */
	public HashMap<String, SignBankVariant> getVariantsList() {
		return variantsList;
	}
	
	@Override
	public String toString() {
		
		String ret = "SignBankMainGloss[";
		ret += "MainGlossID=" + mainGlossID;
		ret += ", MainGlossLabel=" + mainGlossLabel;
		ret += ", Default Variant ID=" + defaultVariantID;
		for (SignBankVariant variant: variantsList.values()) {
			ret += "\n" + variant.toString();
		}
		ret += "\n/SignBankMainGloss]";
		
		return ret;
	}

}
