package edu.bu.signstream.media.fileNavigation;

import java.io.File;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Set;
import java.util.logging.Level;

import javax.swing.JDialog;

import edu.bu.signstream.common.files.MediaFilesLocator;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Database;
import edu.bu.signstream.common.util.vo.ss3.media.SS3MediaFile;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.ui.SS3SignStreamApplication;

public class MediaDelegate {

   public ArrayList<LoadedMediaFile> getLoadedMediaFiles(SignStreamSegmentPanel segment) {
      ArrayList<LoadedMediaFile> list = new ArrayList<LoadedMediaFile>();

      SS3Database db = segment.getSS3Database();
      ArrayList<Object> mfIDs = segment.getExcerpt().getMediaFiles();

      for (int i = 0; i < mfIDs.size(); i++) {        
         SS3MediaFile file = null;         
         Object obj = mfIDs.get(i);
         
         if(obj instanceof String) {
            String id = (String) mfIDs.get(i);
            file = db.getMediaFile(id);
         } else {
            file = (SS3MediaFile)obj;
         }

         if (file != null) {
            LoadedMediaFile lFile = new LoadedMediaFile();
            lFile.setMediaFile(file);

            MediaFilesLocator locator = SS3Singleton.getMediaFilesLocator();

            File ioFile = locator.locateMediaFile(file.getFile().getPath());
            lFile.getMediaFile().setFile(ioFile);
            lFile.setLoaded(isMovieLoaded(ioFile, segment));
            lFile.setLocated(ioFile.exists());
            list.add(lFile);
         } else {
        	 SS3SignStreamApplication.logger.log(Level.INFO, "Coud not locate media file");

            System.out.println("edu.bu.signstream.media.fileNavigation.MediaDelegate: could not locate media file ");
         }
      }
      return list;
   }

   private boolean isMovieLoaded(File file, SignStreamSegmentPanel segment) {
      Hashtable<JDialog, File> dialogs = segment.getOpenedMediaDialogs();
      Set objects = dialogs.keySet();
      Iterator it = objects.iterator();
      while (it.hasNext()) {
         JDialog dialog = (JDialog) it.next();
         Object obj = dialogs.get(dialog);
         File lFile = (File) obj;
         if (lFile.getPath().equals(file.getPath())
            && lFile.getName().equals(file.getName()))
            return true;
      }
      return false;
   }
}
