package edu.bu.signstream.media.fileNavigation;

import java.io.File;
import java.util.ArrayList;

import javax.swing.JDialog;

import edu.bu.signstream.common.util.vo.ss3.media.SS3MediaFile;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.ui.panels.table.sortable.SortableTableModel;

public class MediaTableModel extends SortableTableModel {
   private JDialog parent = null;

   public MediaTableModel(
      Object[] columnNames,
      Object[][] data,
      JDialog parent) {
      super(columnNames, data);
      this.parent = parent;
   }

   public void addNewValue(Object value) {
      int dataSize = data.length;
      int columnSize = columnNames.length;

      Object[][] newData = new Object[dataSize + 1][columnNames.length];

      int i = 0;
      for (i = 0; i < dataSize; i++) {
         for (int j = 0; j < columnSize; j++) {
            Object obj = getValueAt(i, j);
            newData[i][j] = obj;
         }
      }

      newData[i][0] = Boolean.TRUE; //.FALSE;
      newData[i][1] = value;
      newData[i][2] = Boolean.FALSE;
      newData[i][3] = "";
//      newData[i][4] = "";
//      newData[i][5] = "";
//      newData[i][6] = "";
//      newData[i][7] = "";

      this.data = newData;

      fireTableRowsInserted(i, i);
   }

   public void deleteTableRows() {
      int dataSize = data.length;
      int columnSize = columnNames.length;

      int newDataSize = 0;
      for (int i = 0; i < dataSize; i++) {
         Object obj = getValueAt(i, 2);
         Boolean delete = (Boolean) obj;
         if (delete == Boolean.FALSE) {
            newDataSize++;
         }
      }

      Object[][] newData = new Object[newDataSize][columnSize];

      newDataSize = 0;
      for (int i = 0; i < dataSize; i++) {
         Object obj = getValueAt(i, 2);
         Boolean delete = (Boolean) obj;
         if (delete == Boolean.FALSE) {
            for (int j = 0; j < columnSize; j++) {
               Object object = getValueAt(i, j);
               newData[newDataSize][j] = object;
            }
            newDataSize++;
         }
      }

      this.data = newData;

      fireTableDataChanged();
   }

   @Override
public void update(int row, int col) {
      if (col == 0) {
         File file = (File) data[row][1];

         if (file.exists()) {
            Boolean selected = (Boolean) data[row][col];
            data[row][col] = new Boolean(!selected.booleanValue());
         } else {            
            String msg = "<HTML>This video file cannot be selected. <BR> Ctrl + dbl click to relocate.</HTML>";
            SS3Singleton.getSignStreamApplication().confirmationDialog("Resource Update", msg);
         }
      } else if (col == 2) {
         Boolean selected = (Boolean) data[row][col];
         data[row][col] = new Boolean(!selected.booleanValue());
      }
   }

   @Override
public boolean isCellEditable(int row, int col) {
      // Note that the data/cell address is constant,
      // no matter where the cell appears onscreen.
      //return (col == 3 || col == 4 || col == 5 || col == 6);
      return false;
   }

   @Override
public void setValueAt(Object value, int row, int col) {
      data[row][col] = value;
      fireTableCellUpdated(row, col);
   }

   // collection of LoadedMediaFile objects
   public ArrayList getMediaFiles() {
      ArrayList files = new ArrayList();
      int dataSize = data.length;

      for (int i = 0; i < dataSize; i++) {
         Boolean delete = (Boolean) getValueAt(i, 2);

         if (delete.equals(Boolean.FALSE)) {
            Boolean display = (Boolean) getValueAt(i, 0);
            File mFile = (File) getValueAt(i, 1);

            String id = (String) getValueAt(i, 3);

//            String frameRate = (String) getValueAt(i, 3);
//            String color = (String) getValueAt(i, 4);
//            String view = (String) getValueAt(i, 5);
//            String format = (String) getValueAt(i, 6);

            LoadedMediaFile file = new LoadedMediaFile();
           
            file.setLoaded(display.equals(Boolean.TRUE));
            file.setLocated(mFile.exists());

//            SS3MetaData mData = new SS3MetaData();
//            mData.setColor(frameRate);
//            mData.setFormat(color);
//            mData.setFrameRate(view);
//            mData.setView(format);

            SS3MediaFile mediaFile = new SS3MediaFile();
            mediaFile.setFile(mFile);
            mediaFile.setId(id);
            //mediaFile.setMetaData(mData);

            file.setMediaFile(mediaFile);
            files.add(file);
         }
      }
      return files;
   }
}
