package edu.bu.signstream.media.ui;

import edu.bu.signstream.media.MediaPlayer;
import edu.bu.signstream.media.Video;
import edu.bu.signstream.media.ui.icon.SizeLargeIcon;
import edu.bu.signstream.media.ui.icon.SizeSmallIcon;

import javax.swing.*;
import java.awt.*;

public class VideoView extends MediaView {
    private final JComponent image;

    private final ToggleButton resize = new ToggleButton(b -> b ? new SizeSmallIcon(true) : new SizeLargeIcon(true));

    private final Dimension originalSize;
    private final Dimension smallerSize;

    @Override
    protected JComponent view() {
        return image;
    }

    @Override
    protected JPanel controls(JPanel panel) {
        panel.add(resize);
        return panel;
    }

    public VideoView(MediaPlayer player, Video video, JComponent image) {
        super(player, video);

        originalSize = new Dimension(video.width(), video.height());
        smallerSize = new Dimension(video.width() / 2, video.height() / 2);

        this.image = image;
        image.setPreferredSize(originalSize);

        resize.addActionListener(l -> {
            var size = resize.state() ? smallerSize : originalSize;
            image.setPreferredSize(size);
            image.setSize(size);

            resize.toggle();
            pack();
        });

        build();
    }
}
