package edu.bu.signstream.ui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class ConfirmationDialog extends JDialog implements ActionListener {
   private JButton yesBtn = new JButton("Yes");
   private JButton noBtn = new JButton("No");
   
   private final int YES = 0;
   private final int NO = 1;
   
   private JLabel title = new JLabel("Do you want to save changes?", JLabel.CENTER);
   
   private SignStreamDialogInterface dialogInterface;
   
   public ConfirmationDialog(SignStreamDialogInterface dialogInterface) {
      this.dialogInterface = dialogInterface; 
      setTitle("Confirmation dialog");
      
      ButtonPanel btnPanel = new ButtonPanel();
      btnPanel.add(yesBtn);
      btnPanel.add(noBtn);
      
      yesBtn.setActionCommand("" + YES);
      noBtn.setActionCommand("" + NO);
      yesBtn.addActionListener(this);
      noBtn.addActionListener(this);

      yesBtn.setSelected(true);
      
      JPanel panel = new JPanel();
      panel.setLayout(new BorderLayout());
      
      panel.add(title, BorderLayout.CENTER);
      panel.add(btnPanel, BorderLayout.SOUTH);
      
      Dimension d = panel.getPreferredSize();
      Dimension nD = new Dimension(d.width + 60, d.height + 100);
      panel.setPreferredSize(nD);
      
      Container contentPane = getContentPane();
      contentPane.setLayout(new BorderLayout(50, 50));
      contentPane.add(panel, BorderLayout.CENTER);

      this.pack();
   }

   @Override
public void actionPerformed(ActionEvent ae) {
      String str = ae.getActionCommand();

      switch (Integer.parseInt(str)) {
         case YES :
            dialogInterface.saveChanges();
            break;
         case NO :
            dialogInterface.discardChanges();
            break;
      }
      dispose();
    }      
}
