package edu.bu.signstream.ui.panels;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Font;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JDialog;

import edu.bu.signstream.common.util.vo.ss3.participants.SS3Participant;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.ui.panels.newDatabase.ParticipantView;

public class NewAnnotatorDialog extends JDialog {

	private static final long serialVersionUID = 1L;

	private NewAnnotatorPanel newAnnotatorPanel = null;
	
	public NewAnnotatorDialog(JDialog parent, SS3Participant participant, ParticipantView participantView, AnnotatorsPanel annotatorPanel) {
		super(parent, "Create or Edit Annotator", true);
		super.setFont(new Font(super.getFont().getName(), Font.PLAIN, 11));

		newAnnotatorPanel = new NewAnnotatorPanel(participant, participantView, annotatorPanel, this);
		
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				newAnnotatorPanel.cancelEntry();
			}
		});

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout(30, 10));
		contentPane.add(newAnnotatorPanel, BorderLayout.CENTER);
		this.pack();
	}
	
	public NewAnnotatorPanel getNewAnnotatorPanel() {
		return newAnnotatorPanel;
	}
}
