package edu.bu.signstream.ui.panels.codingScheme;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.BorderFactory;
import javax.swing.JDialog;

import edu.bu.signstream.grepresentation.fields.Segment;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.GlossNRelatedView;
import edu.bu.signstream.grepresentation.view.NonmanualFieldsView;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class CSFieldDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private CSFieldPanel csFieldPanel = null;
	
	public CSFieldDialog(SignStreamSegmentPanel segmentPanel, Segment segment,
						 NonmanualFieldsView nonManualView, GlossNRelatedView glossNRelatedView, PresentationField parentField) {
		
		super(SS3Singleton.getSignStreamApplication(), true);	// sets modal to true		
		setTitle("Field Selector");
		
		csFieldPanel = new CSFieldPanel(segmentPanel, segment, nonManualView, this, glossNRelatedView, parentField);
		csFieldPanel.setBorder(BorderFactory.createEmptyBorder(15, 15, 15, 15));
		
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());
		contentPane.add(csFieldPanel, BorderLayout.CENTER);

		addWindowListener(new WindowAdapter() {
			
			@Override
			public void windowClosing(WindowEvent we) {
				//csFieldPanel.discard();
				removeWindowListener(this);
				dispose();
			}
		});

		setSize(
				getPreferredSize().width + 15,
				getPreferredSize().height + 50);
		setLocation(150, 150);
		pack();		
	}
	
	public CSFieldPanel getCSFieldPanel() {
		return csFieldPanel;
	}

	public void setSelectedField(String fieldID, boolean selected) {
		csFieldPanel.select(fieldID, selected);
	}
	
	public void apply() {
	    csFieldPanel.apply();
	}
	
	public Segment getSegment() {
		return csFieldPanel.getSegment();
	}
	
	public void setVisible(boolean b, String fieldID) {
		csFieldPanel.scrollToAndSelectFieldByID(fieldID);
		//csFieldPanel.update();
		super.setVisible(b);
	}

}
