package edu.bu.signstream.ui.panels.colorChooser;

import java.awt.*;
import javax.swing.*;


public class ColorChooser extends JComboBox {
	private ColorComboBoxEditor colorEditor = null;
	
	public ColorChooser() {
		super(
			new Object[] {
				new Item(new Object[] { Color.gray, "" }),
				new Item(new Object[] { Color.orange, "" }),
				new Item(new Object[] { Color.red, "" }),
				new Item(new Object[] { Color.blue, "" }),
				new Item(new Object[] { Color.yellow, "" }),
				new Item(new Object[] { Color.magenta, "" }),
				new Item(new Object[] { Color.black, "" }),
				new Item(new Object[] { Color.green, "" }),
				new Item(new Object[] { Color.lightGray, "" }),
				new Item(new Object[] { Color.white, "" }),
				});

		colorEditor = new ColorComboBoxEditor();
		
		setRenderer(new ColorRendererer());
		setEditor(colorEditor);
		setEditable(true);
	}

	public void setColor(Color color) {
		Item item = new Item(new Object[] { color, null });
		colorEditor.setItem(item);
	}
	
	public Color getColor() {
		Item item = (Item)colorEditor.getItem();
		return item.getColor();
	}

	public void setChooserEnabled(boolean enabled) {
		setEditable(enabled);
		setEnabled(enabled);
	}
}
