package edu.bu.signstream.ui.video;

import java.awt.image.BufferedImage;
import java.util.logging.Level;

import edu.bu.signstream.common.util.vo.ss3.media.SS3MediaFile;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.media.Video;
import edu.bu.signstream.ui.SS3SignStreamApplication;

public class XugglerMovie {
	private String filename = "";

	private SS3MediaFile mediaFile = null;

	private MultipleMovieController controller;
	private VideoImage videoImage;
	private Video video;

	public XugglerMovie(SS3MediaFile mediaFile, MultipleMovieController controller) {
		this.mediaFile = mediaFile;
		this.filename = mediaFile.getFile().getAbsolutePath();
		this.controller = controller;

		if (mediaFile.getFile().exists()) {
            video = controller._addVideo(this);
            openJavaWindow();
        } else {
            throw new RuntimeException("Media file doesn't exist: " + filename);
        }
//		load();
	}

	public SS3MediaFile getSS3MediaFile() {
		return mediaFile;
	}

	public String getFilename() {
		return filename;
	}

	public void close() {
        if (mediaFile.getFile().exists()) {
            controller._removeVideo(video);
            SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
            segmentPanel.getOpenedMediaDialogs().remove(videoImage);
        }
    }

//	public void load() {
//		SS3SignStreamApplication.logger.log(Level.INFO, "First Xuggler call...");
//
//		container = IContainer.make();
//
//		SS3SignStreamApplication.logger.log(Level.INFO, "First Xuggler call went OK!!! ");
//
//		// Open up the container
//		if (container.open(filename, IContainer.Type.READ, null) < 0)
//			throw new IllegalArgumentException("could not open file: " + filename);
//
//		// query how many streams the call to open found
//		int numStreams = container.getNumStreams();
//
//		// and iterate through the streams to find the first video stream
//		for (int i = 0; i < numStreams; i++) {
//			// Find the stream object
//			IStream stream = container.getStream(i);
//			// Get the pre-configured decoder that can decode this stream;
//			IStreamCoder coder = stream.getStreamCoder();
//
//			if (coder.getCodecType() == ICodec.Type.CODEC_TYPE_VIDEO) {
//				videoStreamId = i;
//				videoCoder = coder;
//				break;
//			}
//		}
//		if (videoStreamId == -1)
//			throw new RuntimeException("could not find video stream in container: " + filename);
//
//		// open up the decoder so it can do work.
//		if (videoCoder.open() < 0)
//			throw new RuntimeException("could not open video decoder for container: " + filename);
//
//		if (videoCoder.getPixelType() != IPixelFormat.Type.BGR24) {
//			// if this stream is not in BGR24, we're going to need to
//			// convert it. The VideoResampler does that for us.
//			resampler = IVideoResampler.make(videoCoder.getWidth(), videoCoder.getHeight(), IPixelFormat.Type.BGR24,
//					videoCoder.getWidth(), videoCoder.getHeight(), videoCoder.getPixelType());
//			if (resampler == null)
//				throw new RuntimeException("could not create color space " + "resampler for: " + filename);
//		}
//
//		openJavaWindow();
//	}
//
//	public long getMovieRealTime() {
//		long containerDuration = container.getDuration();	// xuggler container duration in microseconds
//		long movieRealTimeMs = containerDuration / 1000; // movie time in milliseconds
//		return movieRealTimeMs;
//	}
//
//	public double getFrameRate() {
//		IStream videoStream = container.getStream(0);
//		return videoStream.getFrameRate().getDouble();
//	}

//	public void loadNextFrameImage(BufferedImage aJavaImage) {
//		if (this.javaImage != null) {
//			this.javaImage.flush();
//			this.javaImage = null;
//		}
//
//		this.javaImage = aJavaImage;
//		aJavaImage.flush();
//		aJavaImage = null;
//		mScreen.setImage(this.javaImage, false);
//	}

//	public void updateJavaWindow(boolean ignoreRepaint) {
//		mScreen.setImage(javaImage, ignoreRepaint);
//	}

	/**
	 * Draws the video on a screen
	 */
//	public void updateJavaWindow(BufferedImage javaImage, boolean ignoreRepaint) {
//		mScreen.setImage(javaImage, ignoreRepaint);
//	}

	/**
	 * Opens a Swing window on screen.
	 */
	public void openJavaWindow() {
		videoImage = new VideoImage(controller, this, video);
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		segmentPanel.getOpenedMediaDialogs().put(videoImage, mediaFile.getFile());
	}

	public void requestFocus() {
		videoImage.requestFocus();
	}
}
